/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* RISCVPreLegalizerCombinerImpl Combiner Match Table                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct RISCVPreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 192;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 143;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 142;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 197;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 88;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 191;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 87;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 195;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 196;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 93;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 211;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 186;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 130;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 205;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 144;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 188;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 174;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 131;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 126;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 172;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 173;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 160;	 // "commute_shift"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 68;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 123;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 204;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 124;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 171;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 170;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 203;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 206;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 84;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 158;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 169;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 90;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 105;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 53;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 104;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 159;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 67;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 151;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 61;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 141;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 82;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 128;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 57;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 60;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 59;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 58;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 62;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 54;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 187;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 120;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 70;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 89;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 108;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 167;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 152;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 80;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 148;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 122;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 149;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 71;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 127;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 85;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 145;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 134;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 133;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 146;	 // "expand_const_fpowi"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 98;	 // "fptrunc_fpext_fold"
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
          break;
        return 55;	 // "select_of_truncate"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
          break;
        return 117;	 // "sext_inreg_of_load"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 86;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 140;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 165;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 136;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 135;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtend_through_phis", 18) != 0)
        break;
      return 101;	 // "extend_through_phis"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 63;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 210;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 107;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 106;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 83;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 121;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 102;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 193;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 75;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 176;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 97;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 209;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 118;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 125;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 76;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 208;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 194;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 168;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 137;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 92;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 72;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 207;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 198;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 166;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 185;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 156;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 157;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 154;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 111;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 212;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 77;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 175;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 91;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 115;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 95;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 56;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 155;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 138;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 78;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 73;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 119;	 // "narrow_binop_feeding_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_to_zext_inreg", 23) != 0)
        break;
      return 129;	 // "sext_inreg_to_zext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 147;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 162;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 94;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 199;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 65;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 116;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 100;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 74;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 190;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 153;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 99;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 201;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 189;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 113;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 114;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 96;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 202;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 112;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 132;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 79;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 150;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 164;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 69;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 200;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 110;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 161;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 177;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 181;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 66;	 // "extract_all_elts_from_build_vector"
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 179;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 64;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 81;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 182;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 103;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 178;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 183;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 180;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 184;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 213}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool RISCVPreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool RISCVPreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> RISCVPreLegalizerCombinerOption;
static cl::list<std::string> RISCVPreLegalizerCombinerDisableOption(
    "riscvprelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the RISCVPreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      RISCVPreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> RISCVPreLegalizerCombinerOnlyEnableOption(
    "riscvprelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the RISCVPreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      RISCVPreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        RISCVPreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool RISCVPreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool RISCVPreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : RISCVPreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVPreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVPreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVPreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVPreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset RISCVPreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void RISCVPreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVPreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

RISCVPreLegalizerCombinerImpl::ComplexMatcherMemFn
RISCVPreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool RISCVPreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
};

bool RISCVPreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
RISCVPreLegalizerCombinerImpl::CustomRendererFn
RISCVPreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool RISCVPreLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
};
bool RISCVPreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVPreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(260), /*)*//*default:*//*Label 95*/ GIMT_Encode4(6982),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(970), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(982),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1539),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(1857),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2023),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2096),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2180),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2225), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2292),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2573),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(2818), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(2919), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 12*/ GIMT_Encode4(2931), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 13*/ GIMT_Encode4(2998),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 14*/ GIMT_Encode4(3072),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 15*/ GIMT_Encode4(3120),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 16*/ GIMT_Encode4(3132),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 17*/ GIMT_Encode4(3144),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 18*/ GIMT_Encode4(3187),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 19*/ GIMT_Encode4(3220),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 20*/ GIMT_Encode4(3263), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(3327),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(3339),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(3351), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(3363), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  454 */ /*TargetOpcode::G_ANYEXT*//*Label 25*/ GIMT_Encode4(3375),
     /*  458 */ /*TargetOpcode::G_TRUNC*//*Label 26*/ GIMT_Encode4(3503), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  478 */ /*TargetOpcode::G_SEXT*//*Label 27*/ GIMT_Encode4(3861),
     /*  482 */ /*TargetOpcode::G_SEXT_INREG*//*Label 28*/ GIMT_Encode4(3936),
     /*  486 */ /*TargetOpcode::G_ZEXT*//*Label 29*/ GIMT_Encode4(3981),
     /*  490 */ /*TargetOpcode::G_SHL*//*Label 30*/ GIMT_Encode4(4111),
     /*  494 */ /*TargetOpcode::G_LSHR*//*Label 31*/ GIMT_Encode4(4280),
     /*  498 */ /*TargetOpcode::G_ASHR*//*Label 32*/ GIMT_Encode4(4403),
     /*  502 */ /*TargetOpcode::G_FSHL*//*Label 33*/ GIMT_Encode4(4537),
     /*  506 */ /*TargetOpcode::G_FSHR*//*Label 34*/ GIMT_Encode4(4580),
     /*  510 */ /*TargetOpcode::G_ROTR*//*Label 35*/ GIMT_Encode4(4623),
     /*  514 */ /*TargetOpcode::G_ROTL*//*Label 36*/ GIMT_Encode4(4647),
     /*  518 */ /*TargetOpcode::G_ICMP*//*Label 37*/ GIMT_Encode4(4671),
     /*  522 */ /*TargetOpcode::G_FCMP*//*Label 38*/ GIMT_Encode4(4716), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  534 */ /*TargetOpcode::G_SELECT*//*Label 39*/ GIMT_Encode4(4728),
     /*  538 */ /*TargetOpcode::G_UADDO*//*Label 40*/ GIMT_Encode4(4823),
     /*  542 */ /*TargetOpcode::G_UADDE*//*Label 41*/ GIMT_Encode4(4846),
     /*  546 */ /*TargetOpcode::G_USUBO*//*Label 42*/ GIMT_Encode4(4858),
     /*  550 */ /*TargetOpcode::G_USUBE*//*Label 43*/ GIMT_Encode4(4870),
     /*  554 */ /*TargetOpcode::G_SADDO*//*Label 44*/ GIMT_Encode4(4882),
     /*  558 */ /*TargetOpcode::G_SADDE*//*Label 45*/ GIMT_Encode4(4905),
     /*  562 */ /*TargetOpcode::G_SSUBO*//*Label 46*/ GIMT_Encode4(4917),
     /*  566 */ /*TargetOpcode::G_SSUBE*//*Label 47*/ GIMT_Encode4(4929),
     /*  570 */ /*TargetOpcode::G_UMULO*//*Label 48*/ GIMT_Encode4(4941),
     /*  574 */ /*TargetOpcode::G_SMULO*//*Label 49*/ GIMT_Encode4(4975),
     /*  578 */ /*TargetOpcode::G_UMULH*//*Label 50*/ GIMT_Encode4(5009),
     /*  582 */ /*TargetOpcode::G_SMULH*//*Label 51*/ GIMT_Encode4(5032),
     /*  586 */ /*TargetOpcode::G_UADDSAT*//*Label 52*/ GIMT_Encode4(5044),
     /*  590 */ /*TargetOpcode::G_SADDSAT*//*Label 53*/ GIMT_Encode4(5056), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  602 */ /*TargetOpcode::G_USHLSAT*//*Label 54*/ GIMT_Encode4(5068),
     /*  606 */ /*TargetOpcode::G_SSHLSAT*//*Label 55*/ GIMT_Encode4(5091),
     /*  610 */ /*TargetOpcode::G_SMULFIX*//*Label 56*/ GIMT_Encode4(5114),
     /*  614 */ /*TargetOpcode::G_UMULFIX*//*Label 57*/ GIMT_Encode4(5126),
     /*  618 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 58*/ GIMT_Encode4(5138),
     /*  622 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 59*/ GIMT_Encode4(5150), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  642 */ /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(5162),
     /*  646 */ /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(5274),
     /*  650 */ /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(5363),
     /*  654 */ /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(5451),
     /*  658 */ /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(5474),
     /*  662 */ /*TargetOpcode::G_FDIV*//*Label 65*/ GIMT_Encode4(5497),
     /*  666 */ /*TargetOpcode::G_FREM*//*Label 66*/ GIMT_Encode4(5531), GIMT_Encode4(0),
     /*  674 */ /*TargetOpcode::G_FPOWI*//*Label 67*/ GIMT_Encode4(5543), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_FLOG2*//*Label 68*/ GIMT_Encode4(5565), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  710 */ /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(5587), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FPTRUNC*//*Label 70*/ GIMT_Encode4(5638),
     /*  722 */ /*TargetOpcode::G_FPTOSI*//*Label 71*/ GIMT_Encode4(5681),
     /*  726 */ /*TargetOpcode::G_FPTOUI*//*Label 72*/ GIMT_Encode4(5703),
     /*  730 */ /*TargetOpcode::G_SITOFP*//*Label 73*/ GIMT_Encode4(5725),
     /*  734 */ /*TargetOpcode::G_UITOFP*//*Label 74*/ GIMT_Encode4(5752), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  746 */ /*TargetOpcode::G_FABS*//*Label 75*/ GIMT_Encode4(5779), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  758 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 76*/ GIMT_Encode4(5858),
     /*  762 */ /*TargetOpcode::G_FMINNUM*//*Label 77*/ GIMT_Encode4(5888),
     /*  766 */ /*TargetOpcode::G_FMAXNUM*//*Label 78*/ GIMT_Encode4(5922),
     /*  770 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 79*/ GIMT_Encode4(5956),
     /*  774 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 80*/ GIMT_Encode4(5968),
     /*  778 */ /*TargetOpcode::G_FMINIMUM*//*Label 81*/ GIMT_Encode4(5980),
     /*  782 */ /*TargetOpcode::G_FMAXIMUM*//*Label 82*/ GIMT_Encode4(6014), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  810 */ /*TargetOpcode::G_PTR_ADD*//*Label 83*/ GIMT_Encode4(6048), GIMT_Encode4(0),
     /*  818 */ /*TargetOpcode::G_SMIN*//*Label 84*/ GIMT_Encode4(6138),
     /*  822 */ /*TargetOpcode::G_SMAX*//*Label 85*/ GIMT_Encode4(6172),
     /*  826 */ /*TargetOpcode::G_UMIN*//*Label 86*/ GIMT_Encode4(6206),
     /*  830 */ /*TargetOpcode::G_UMAX*//*Label 87*/ GIMT_Encode4(6240),
     /*  834 */ /*TargetOpcode::G_ABS*//*Label 88*/ GIMT_Encode4(6274), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  846 */ /*TargetOpcode::G_BR*//*Label 89*/ GIMT_Encode4(6286), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  866 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(6298),
     /*  870 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(6428),
     /*  874 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 92*/ GIMT_Encode4(6805), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  914 */ /*TargetOpcode::G_BITREVERSE*//*Label 93*/ GIMT_Encode4(6871), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  966 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(6960),
     /*  970 */ // Label 0: @970
     /*  970 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(981), // Rule ID 13 //
     /*  975 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /*  978 */   // MIs[0] d
     /*  978 */   // No operand predicates
     /*  978 */   // MIs[0] s
     /*  978 */   // No operand predicates
     /*  978 */   // Combiner Rule #13: copy_prop
     /*  978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  981 */ // Label 96: @981
     /*  981 */ GIM_Reject,
     /*  982 */ // Label 1: @982
     /*  982 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(993), // Rule ID 16 //
     /*  987 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /*  990 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /*  990 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /*  993 */ // Label 97: @993
     /*  993 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1004), // Rule ID 93 //
     /*  998 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1001 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1001 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1004 */ // Label 98: @1004
     /* 1004 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1015), // Rule ID 140 //
     /* 1009 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 1012 */   // Combiner Rule #102: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1012 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 1015 */ // Label 99: @1015
     /* 1015 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1026), // Rule ID 230 //
     /* 1020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 1023 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1026 */ // Label 100: @1026
     /* 1026 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1037), // Rule ID 278 //
     /* 1031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 1034 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1034 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1037 */ // Label 101: @1037
     /* 1037 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1048), // Rule ID 307 //
     /* 1042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 1045 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 1048 */ // Label 102: @1048
     /* 1048 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1082), // Rule ID 0 //
     /* 1053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1056 */   // MIs[0] root
     /* 1056 */   // No operand predicates
     /* 1056 */   // MIs[0] sub
     /* 1056 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1064 */   // MIs[1] Operand 1
     /* 1064 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1068 */   // MIs[1] A
     /* 1068 */   // No operand predicates
     /* 1068 */   // MIs[0] B
     /* 1068 */   // No operand predicates
     /* 1068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1070 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1073 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1075 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1077 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1081 */   GIR_EraseRootFromParent_Done,
     /* 1082 */ // Label 103: @1082
     /* 1082 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1119), // Rule ID 12 //
     /* 1087 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1090 */   // MIs[0] root
     /* 1090 */   // No operand predicates
     /* 1090 */   // MIs[0] sub
     /* 1090 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1098 */   // MIs[1] A
     /* 1098 */   // No operand predicates
     /* 1098 */   // MIs[1] c1
     /* 1098 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1102 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1106 */   // MIs[2] imm1
     /* 1106 */   // No operand predicates
     /* 1106 */   // MIs[0] c2
     /* 1106 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1110 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1114 */   // MIs[3] imm2
     /* 1114 */   // No operand predicates
     /* 1114 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1116 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1119 */ // Label 104: @1119
     /* 1119 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1153), // Rule ID 3 //
     /* 1124 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1127 */   // MIs[0] root
     /* 1127 */   // No operand predicates
     /* 1127 */   // MIs[0] sub
     /* 1127 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1135 */   // MIs[1] B
     /* 1135 */   // No operand predicates
     /* 1135 */   // MIs[1] A
     /* 1135 */   // No operand predicates
     /* 1135 */   // MIs[0] A
     /* 1135 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1140 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1145 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1147 */   // Combiner Rule #3: BMinusAPlusA
     /* 1147 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1152 */   GIR_EraseRootFromParent_Done,
     /* 1153 */ // Label 105: @1153
     /* 1153 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1187), // Rule ID 130 //
     /* 1158 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1161 */   // MIs[0] dst
     /* 1161 */   // No operand predicates
     /* 1161 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1161 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1169 */   // MIs[1] src
     /* 1169 */   // No operand predicates
     /* 1169 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1169 */   // No operand predicates
     /* 1169 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1169 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1174 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1181 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1181 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1186 */   GIR_EraseRootFromParent_Done,
     /* 1187 */ // Label 106: @1187
     /* 1187 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1232), // Rule ID 5 //
     /* 1192 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1195 */   // MIs[0] root
     /* 1195 */   // No operand predicates
     /* 1195 */   // MIs[0] sub1
     /* 1195 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1203 */   // MIs[1] A
     /* 1203 */   // No operand predicates
     /* 1203 */   // MIs[1] B
     /* 1203 */   // No operand predicates
     /* 1203 */   // MIs[0] sub2
     /* 1203 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1207 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1211 */   // MIs[2] B
     /* 1211 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1216 */   // MIs[2] C
     /* 1216 */   // No operand predicates
     /* 1216 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1218 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1221 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1223 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1227 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1231 */   GIR_EraseRootFromParent_Done,
     /* 1232 */ // Label 107: @1232
     /* 1232 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1277), // Rule ID 4 //
     /* 1237 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1240 */   // MIs[0] root
     /* 1240 */   // No operand predicates
     /* 1240 */   // MIs[0] sub1
     /* 1240 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1248 */   // MIs[1] A
     /* 1248 */   // No operand predicates
     /* 1248 */   // MIs[1] B
     /* 1248 */   // No operand predicates
     /* 1248 */   // MIs[0] sub2
     /* 1248 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1252 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1256 */   // MIs[2] C
     /* 1256 */   // No operand predicates
     /* 1256 */   // MIs[2] A
     /* 1256 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1261 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1263 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1266 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1268 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1272 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1276 */   GIR_EraseRootFromParent_Done,
     /* 1277 */ // Label 108: @1277
     /* 1277 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1312), // Rule ID 39 //
     /* 1282 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1285 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1291 */   // MIs[0] root
     /* 1291 */   // No operand predicates
     /* 1291 */   // MIs[0] left
     /* 1291 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1299 */   // MIs[1] imm1
     /* 1299 */   // No operand predicates
     /* 1299 */   // MIs[0] right
     /* 1299 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1303 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1307 */   // MIs[2] imm2
     /* 1307 */   // No operand predicates
     /* 1307 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1309 */   // Combiner Rule #37: add_of_vscale
     /* 1309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1312 */ // Label 109: @1312
     /* 1312 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1346), // Rule ID 1 //
     /* 1317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1320 */   // MIs[0] root
     /* 1320 */   // No operand predicates
     /* 1320 */   // MIs[0] A
     /* 1320 */   // No operand predicates
     /* 1320 */   // MIs[0] sub
     /* 1320 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1328 */   // MIs[1] Operand 1
     /* 1328 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1332 */   // MIs[1] B
     /* 1332 */   // No operand predicates
     /* 1332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1337 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1339 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1341 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1345 */   GIR_EraseRootFromParent_Done,
     /* 1346 */ // Label 110: @1346
     /* 1346 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1380), // Rule ID 2 //
     /* 1351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1354 */   // MIs[0] root
     /* 1354 */   // No operand predicates
     /* 1354 */   // MIs[0] A
     /* 1354 */   // No operand predicates
     /* 1354 */   // MIs[0] sub
     /* 1354 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1362 */   // MIs[1] B
     /* 1362 */   // No operand predicates
     /* 1362 */   // MIs[1] A
     /* 1362 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1367 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374 */   // Combiner Rule #2: APlusBMinusB
     /* 1374 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1379 */   GIR_EraseRootFromParent_Done,
     /* 1380 */ // Label 111: @1380
     /* 1380 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1414), // Rule ID 129 //
     /* 1385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1388 */   // MIs[0] dst
     /* 1388 */   // No operand predicates
     /* 1388 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1388 */   // No operand predicates
     /* 1388 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1388 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1396 */   // MIs[1] src
     /* 1396 */   // No operand predicates
     /* 1396 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1396 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1401 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1408 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1408 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1413 */   GIR_EraseRootFromParent_Done,
     /* 1414 */ // Label 112: @1414
     /* 1414 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1459), // Rule ID 6 //
     /* 1419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1422 */   // MIs[0] root
     /* 1422 */   // No operand predicates
     /* 1422 */   // MIs[0] A
     /* 1422 */   // No operand predicates
     /* 1422 */   // MIs[0] sub1
     /* 1422 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1430 */   // MIs[1] B
     /* 1430 */   // No operand predicates
     /* 1430 */   // MIs[1] add1
     /* 1430 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1434 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1438 */   // MIs[2] A
     /* 1438 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1443 */   // MIs[2] C
     /* 1443 */   // No operand predicates
     /* 1443 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1445 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1448 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1450 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1454 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1458 */   GIR_EraseRootFromParent_Done,
     /* 1459 */ // Label 113: @1459
     /* 1459 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1504), // Rule ID 7 //
     /* 1464 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1467 */   // MIs[0] root
     /* 1467 */   // No operand predicates
     /* 1467 */   // MIs[0] A
     /* 1467 */   // No operand predicates
     /* 1467 */   // MIs[0] sub1
     /* 1467 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1475 */   // MIs[1] B
     /* 1475 */   // No operand predicates
     /* 1475 */   // MIs[1] add1
     /* 1475 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1479 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1483 */   // MIs[2] C
     /* 1483 */   // No operand predicates
     /* 1483 */   // MIs[2] A
     /* 1483 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1488 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1490 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1493 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1495 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1499 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1503 */   GIR_EraseRootFromParent_Done,
     /* 1504 */ // Label 114: @1504
     /* 1504 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1527), // Rule ID 104 //
     /* 1509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 1512 */   // MIs[0] dst
     /* 1512 */   // No operand predicates
     /* 1512 */   // MIs[0] lhs
     /* 1512 */   // No operand predicates
     /* 1512 */   // MIs[0] Operand 2
     /* 1512 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1516 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1521 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1521 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1526 */   GIR_EraseRootFromParent_Done,
     /* 1527 */ // Label 115: @1527
     /* 1527 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1538), // Rule ID 148 //
     /* 1532 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 1535 */   // MIs[0] root
     /* 1535 */   // No operand predicates
     /* 1535 */   // MIs[0] src1
     /* 1535 */   // No operand predicates
     /* 1535 */   // MIs[0] src2
     /* 1535 */   // No operand predicates
     /* 1535 */   // Combiner Rule #106: reassoc_comm_binops
     /* 1535 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 1538 */ // Label 116: @1538
     /* 1538 */ GIM_Reject,
     /* 1539 */ // Label 2: @1539
     /* 1539 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1550), // Rule ID 94 //
     /* 1544 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1547 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1547 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1550 */ // Label 117: @1550
     /* 1550 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1561), // Rule ID 238 //
     /* 1555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 1558 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1558 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1561 */ // Label 118: @1561
     /* 1561 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1572), // Rule ID 279 //
     /* 1566 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 1569 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1569 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1572 */ // Label 119: @1572
     /* 1572 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1583), // Rule ID 304 //
     /* 1577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1580 */   // Combiner Rule #186: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1583 */ // Label 120: @1583
     /* 1583 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1594), // Rule ID 338 //
     /* 1588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 1591 */   // Combiner Rule #193: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1591 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 1594 */ // Label 121: @1594
     /* 1594 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1631), // Rule ID 8 //
     /* 1599 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1602 */   // MIs[0] root
     /* 1602 */   // No operand predicates
     /* 1602 */   // MIs[0] add
     /* 1602 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1610 */   // MIs[1] A
     /* 1610 */   // No operand predicates
     /* 1610 */   // MIs[1] c1
     /* 1610 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1614 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1618 */   // MIs[2] imm1
     /* 1618 */   // No operand predicates
     /* 1618 */   // MIs[0] c2
     /* 1618 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1622 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1626 */   // MIs[3] imm2
     /* 1626 */   // No operand predicates
     /* 1626 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1628 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1628 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1631 */ // Label 122: @1631
     /* 1631 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1668), // Rule ID 11 //
     /* 1636 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1639 */   // MIs[0] root
     /* 1639 */   // No operand predicates
     /* 1639 */   // MIs[0] sub1
     /* 1639 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1647 */   // MIs[1] c1
     /* 1647 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1651 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1655 */   // MIs[2] imm1
     /* 1655 */   // No operand predicates
     /* 1655 */   // MIs[1] A
     /* 1655 */   // No operand predicates
     /* 1655 */   // MIs[0] c2
     /* 1655 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1659 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1663 */   // MIs[3] imm2
     /* 1663 */   // No operand predicates
     /* 1663 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1665 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1668 */ // Label 123: @1668
     /* 1668 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1705), // Rule ID 10 //
     /* 1673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1676 */   // MIs[0] root
     /* 1676 */   // No operand predicates
     /* 1676 */   // MIs[0] sub1
     /* 1676 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1684 */   // MIs[1] A
     /* 1684 */   // No operand predicates
     /* 1684 */   // MIs[1] c1
     /* 1684 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1688 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1692 */   // MIs[2] imm1
     /* 1692 */   // No operand predicates
     /* 1692 */   // MIs[0] c2
     /* 1692 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1696 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1700 */   // MIs[3] imm2
     /* 1700 */   // No operand predicates
     /* 1700 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1702 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1702 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1705 */ // Label 124: @1705
     /* 1705 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1748), // Rule ID 158 //
     /* 1710 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 1713 */   // MIs[0] dst
     /* 1713 */   // No operand predicates
     /* 1713 */   // MIs[0] Operand 1
     /* 1713 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 1717 */   // MIs[0] and
     /* 1717 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 1725 */   // MIs[1] x
     /* 1725 */   // No operand predicates
     /* 1725 */   // MIs[1] Operand 2
     /* 1725 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 1729 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 1733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1735 */   // Combiner Rule #116: neg_and_one_to_sext_inreg
     /* 1735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 1738 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1740 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 1744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1747 */   GIR_EraseRootFromParent_Done,
     /* 1748 */ // Label 125: @1748
     /* 1748 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1785), // Rule ID 9 //
     /* 1753 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1756 */   // MIs[0] root
     /* 1756 */   // No operand predicates
     /* 1756 */   // MIs[0] c2
     /* 1756 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1764 */   // MIs[1] imm2
     /* 1764 */   // No operand predicates
     /* 1764 */   // MIs[0] add
     /* 1764 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1768 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1772 */   // MIs[2] A
     /* 1772 */   // No operand predicates
     /* 1772 */   // MIs[2] c1
     /* 1772 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 1776 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1780 */   // MIs[3] imm1
     /* 1780 */   // No operand predicates
     /* 1780 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1782 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 1782 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1785 */ // Label 126: @1785
     /* 1785 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1812), // Rule ID 42 //
     /* 1790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 1793 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1799 */   // MIs[0] root
     /* 1799 */   // No operand predicates
     /* 1799 */   // MIs[0] x
     /* 1799 */   // No operand predicates
     /* 1799 */   // MIs[0] right
     /* 1799 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1803 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1807 */   // MIs[1] imm
     /* 1807 */   // No operand predicates
     /* 1807 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1809 */   // Combiner Rule #40: sub_of_vscale
     /* 1809 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 1812 */ // Label 127: @1812
     /* 1812 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1835), // Rule ID 103 //
     /* 1817 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 1820 */   // MIs[0] dst
     /* 1820 */   // No operand predicates
     /* 1820 */   // MIs[0] lhs
     /* 1820 */   // No operand predicates
     /* 1820 */   // MIs[0] Operand 2
     /* 1820 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1824 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1829 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 1829 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1834 */   GIR_EraseRootFromParent_Done,
     /* 1835 */ // Label 128: @1835
     /* 1835 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1856), // Rule ID 15 //
     /* 1840 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 1843 */   // MIs[0] d
     /* 1843 */   // No operand predicates
     /* 1843 */   // MIs[0] op1
     /* 1843 */   // No operand predicates
     /* 1843 */   // MIs[0] c
     /* 1843 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1851 */   // MIs[1] imm
     /* 1851 */   // No operand predicates
     /* 1851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1853 */   // Combiner Rule #15: sub_to_add
     /* 1853 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1856 */ // Label 129: @1856
     /* 1856 */ GIM_Reject,
     /* 1857 */ // Label 3: @1857
     /* 1857 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1868), // Rule ID 77 //
     /* 1862 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 1865 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 1865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 1868 */ // Label 130: @1868
     /* 1868 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1879), // Rule ID 235 //
     /* 1873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 1876 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 1876 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1879 */ // Label 131: @1879
     /* 1879 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1890), // Rule ID 308 //
     /* 1884 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 1887 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 1887 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 1890 */ // Label 132: @1890
     /* 1890 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1930), // Rule ID 17 //
     /* 1895 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1898 */   // MIs[0] dst
     /* 1898 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 1902 */   // MIs[0] x
     /* 1902 */   // No operand predicates
     /* 1902 */   // MIs[0] Operand 2
     /* 1902 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 1906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 1909 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 1919 */   // Combiner Rule #17: mul_by_neg_one
     /* 1919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1922 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1927 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1929 */   GIR_EraseRootFromParent_Done,
     /* 1930 */ // Label 133: @1930
     /* 1930 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1965), // Rule ID 40 //
     /* 1935 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 1938 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1944 */   // MIs[0] root
     /* 1944 */   // No operand predicates
     /* 1944 */   // MIs[0] left
     /* 1944 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1952 */   // MIs[1] scale
     /* 1952 */   // No operand predicates
     /* 1952 */   // MIs[0] x
     /* 1952 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1956 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1960 */   // MIs[2] imm1
     /* 1960 */   // No operand predicates
     /* 1960 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1962 */   // Combiner Rule #38: mul_of_vscale
     /* 1962 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 1965 */ // Label 134: @1965
     /* 1965 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(1988), // Rule ID 122 //
     /* 1970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 1973 */   // MIs[0] dst
     /* 1973 */   // No operand predicates
     /* 1973 */   // MIs[0] lhs
     /* 1973 */   // No operand predicates
     /* 1973 */   // MIs[0] zero
     /* 1973 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1977 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1982 */   // Combiner Rule #86: binop_right_to_zero
     /* 1982 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1987 */   GIR_EraseRootFromParent_Done,
     /* 1988 */ // Label 135: @1988
     /* 1988 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2011), // Rule ID 127 //
     /* 1993 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 1996 */   // MIs[0] dst
     /* 1996 */   // No operand predicates
     /* 1996 */   // MIs[0] x
     /* 1996 */   // No operand predicates
     /* 1996 */   // MIs[0] Operand 2
     /* 1996 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2000 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2005 */   // Combiner Rule #91: right_identity_one_int
     /* 2005 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2010 */   GIR_EraseRootFromParent_Done,
     /* 2011 */ // Label 136: @2011
     /* 2011 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2022), // Rule ID 14 //
     /* 2016 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2019 */   // MIs[0] d
     /* 2019 */   // No operand predicates
     /* 2019 */   // MIs[0] op1
     /* 2019 */   // No operand predicates
     /* 2019 */   // MIs[0] op2
     /* 2019 */   // No operand predicates
     /* 2019 */   // Combiner Rule #14: mul_to_shl
     /* 2019 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2022 */ // Label 137: @2022
     /* 2022 */ GIM_Reject,
     /* 2023 */ // Label 4: @2023
     /* 2023 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2034), // Rule ID 118 //
     /* 2028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2031 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2034 */ // Label 138: @2034
     /* 2034 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2045), // Rule ID 210 //
     /* 2039 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2042 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2045 */ // Label 139: @2045
     /* 2045 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2056), // Rule ID 241 //
     /* 2050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2053 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2056 */ // Label 140: @2056
     /* 2056 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2067), // Rule ID 259 //
     /* 2061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2064 */   // Combiner Rule #171: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2064 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2067 */ // Label 141: @2067
     /* 2067 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2078), // Rule ID 284 //
     /* 2072 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2075 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2075 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2078 */ // Label 142: @2078
     /* 2078 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2095), // Rule ID 260 //
     /* 2083 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2086 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2092 */   // MIs[0] dst
     /* 2092 */   // No operand predicates
     /* 2092 */   // MIs[0] x
     /* 2092 */   // No operand predicates
     /* 2092 */   // MIs[0] y
     /* 2092 */   // No operand predicates
     /* 2092 */   // Combiner Rule #172: sdiv_by_pow2
     /* 2092 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2095 */ // Label 143: @2095
     /* 2095 */ GIM_Reject,
     /* 2096 */ // Label 5: @2096
     /* 2096 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2107), // Rule ID 80 //
     /* 2101 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2104 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2104 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2107 */ // Label 144: @2107
     /* 2107 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2118), // Rule ID 119 //
     /* 2112 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2115 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2115 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2118 */ // Label 145: @2118
     /* 2118 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2129), // Rule ID 211 //
     /* 2123 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2126 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2126 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2129 */ // Label 146: @2129
     /* 2129 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2140), // Rule ID 240 //
     /* 2134 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2137 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2137 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2140 */ // Label 147: @2140
     /* 2140 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2151), // Rule ID 258 //
     /* 2145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 2148 */   // Combiner Rule #170: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2148 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 2151 */ // Label 148: @2151
     /* 2151 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2162), // Rule ID 286 //
     /* 2156 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2159 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2159 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2162 */ // Label 149: @2162
     /* 2162 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2179), // Rule ID 261 //
     /* 2167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2170 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2176 */   // MIs[0] dst
     /* 2176 */   // No operand predicates
     /* 2176 */   // MIs[0] x
     /* 2176 */   // No operand predicates
     /* 2176 */   // MIs[0] y
     /* 2176 */   // No operand predicates
     /* 2176 */   // Combiner Rule #173: udiv_by_pow2
     /* 2176 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2179 */ // Label 150: @2179
     /* 2179 */ GIM_Reject,
     /* 2180 */ // Label 6: @2180
     /* 2180 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2191), // Rule ID 120 //
     /* 2185 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2188 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2188 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2191 */ // Label 151: @2191
     /* 2191 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2202), // Rule ID 212 //
     /* 2196 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2199 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2199 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2202 */ // Label 152: @2202
     /* 2202 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2213), // Rule ID 243 //
     /* 2207 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2210 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2210 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2213 */ // Label 153: @2213
     /* 2213 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2224), // Rule ID 285 //
     /* 2218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2221 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2221 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2224 */ // Label 154: @2224
     /* 2224 */ GIM_Reject,
     /* 2225 */ // Label 7: @2225
     /* 2225 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2236), // Rule ID 81 //
     /* 2230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2233 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2236 */ // Label 155: @2236
     /* 2236 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2247), // Rule ID 121 //
     /* 2241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2244 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2244 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2247 */ // Label 156: @2247
     /* 2247 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2258), // Rule ID 169 //
     /* 2252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2255 */   // Combiner Rule #127: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2258 */ // Label 157: @2258
     /* 2258 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2269), // Rule ID 213 //
     /* 2263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2266 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2266 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2269 */ // Label 158: @2269
     /* 2269 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2280), // Rule ID 242 //
     /* 2274 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2277 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2277 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2280 */ // Label 159: @2280
     /* 2280 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2291), // Rule ID 287 //
     /* 2285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2288 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2288 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2291 */ // Label 160: @2291
     /* 2291 */ GIM_Reject,
     /* 2292 */ // Label 8: @2292
     /* 2292 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2303), // Rule ID 72 //
     /* 2297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 2300 */   // Combiner Rule #68: load_and_mask; wip_match_opcode 'G_AND'
     /* 2300 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 2303 */ // Label 161: @2303
     /* 2303 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2314), // Rule ID 76 //
     /* 2308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2311 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2311 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 2314 */ // Label 162: @2314
     /* 2314 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2325), // Rule ID 141 //
     /* 2319 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2322 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2322 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2325 */ // Label 163: @2325
     /* 2325 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2336), // Rule ID 161 //
     /* 2330 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 2333 */   // Combiner Rule #119: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2333 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2336 */ // Label 164: @2336
     /* 2336 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2347), // Rule ID 166 //
     /* 2341 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 2344 */   // Combiner Rule #124: redundant_and; wip_match_opcode 'G_AND'
     /* 2344 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 2347 */ // Label 165: @2347
     /* 2347 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2358), // Rule ID 183 //
     /* 2352 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 2355 */   // Combiner Rule #141: overlapping_and; wip_match_opcode 'G_AND'
     /* 2355 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 2358 */ // Label 166: @2358
     /* 2358 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2369), // Rule ID 232 //
     /* 2363 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2366 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2366 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2369 */ // Label 167: @2369
     /* 2369 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2380), // Rule ID 269 //
     /* 2374 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 2377 */   // Combiner Rule #176: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2377 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 2380 */ // Label 168: @2380
     /* 2380 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2391), // Rule ID 281 //
     /* 2385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2388 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2391 */ // Label 169: @2391
     /* 2391 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2402), // Rule ID 309 //
     /* 2396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 2399 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2402 */ // Label 170: @2402
     /* 2402 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2413), // Rule ID 336 //
     /* 2407 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2410 */   // Combiner Rule #191: match_ands; wip_match_opcode 'G_AND'
     /* 2410 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 2413 */ // Label 171: @2413
     /* 2413 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2511), // Rule ID 154 //
     /* 2418 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 2421 */   // MIs[0] root
     /* 2421 */   // No operand predicates
     /* 2421 */   // MIs[0] d1
     /* 2421 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2429 */   // MIs[1] p
     /* 2429 */   // No operand predicates
     /* 2429 */   // MIs[1] s1
     /* 2429 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2433 */   // MIs[1] Operand 3
     /* 2433 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2437 */   // MIs[0] d2
     /* 2437 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2441 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2445 */   // MIs[2] p
     /* 2445 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2450 */   // MIs[2] s2
     /* 2450 */   // No operand predicates
     /* 2450 */   // MIs[2] Operand 3
     /* 2450 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2454 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2458 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2460 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2463 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2476 */   // Combiner Rule #112: double_icmp_zero_and_combine
     /* 2476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2479 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2484 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2488 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2496 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2500 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2504 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2507 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2510 */   GIR_EraseRootFromParent_Done,
     /* 2511 */ // Label 172: @2511
     /* 2511 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2548), // Rule ID 225 //
     /* 2516 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 2519 */   // MIs[0] root
     /* 2519 */   // No operand predicates
     /* 2519 */   // MIs[0] shift
     /* 2519 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2527 */   // MIs[1] x
     /* 2527 */   // No operand predicates
     /* 2527 */   // MIs[1] lsb
     /* 2527 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2531 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2535 */   // MIs[2] imm1
     /* 2535 */   // No operand predicates
     /* 2535 */   // MIs[0] mask
     /* 2535 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2539 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2543 */   // MIs[3] imm2
     /* 2543 */   // No operand predicates
     /* 2543 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2545 */   // Combiner Rule #162: bitfield_extract_from_and
     /* 2545 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 2548 */ // Label 173: @2548
     /* 2548 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2572), // Rule ID 113 //
     /* 2553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2556 */   // MIs[0] dst
     /* 2556 */   // No operand predicates
     /* 2556 */   // MIs[0] src
     /* 2556 */   // No operand predicates
     /* 2556 */   // MIs[0] src
     /* 2556 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2561 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2566 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2566 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2571 */   GIR_EraseRootFromParent_Done,
     /* 2572 */ // Label 174: @2572
     /* 2572 */ GIM_Reject,
     /* 2573 */ // Label 9: @2573
     /* 2573 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2584), // Rule ID 78 //
     /* 2578 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2581 */   // Combiner Rule #72: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2581 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2584 */ // Label 175: @2584
     /* 2584 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2595), // Rule ID 142 //
     /* 2589 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2592 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2592 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2595 */ // Label 176: @2595
     /* 2595 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2606), // Rule ID 168 //
     /* 2600 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 2603 */   // Combiner Rule #126: redundant_or; wip_match_opcode 'G_OR'
     /* 2603 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 2606 */ // Label 177: @2606
     /* 2606 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2617), // Rule ID 209 //
     /* 2611 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2614 */   // Combiner Rule #151: load_or_combine; wip_match_opcode 'G_OR'
     /* 2614 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 2617 */ // Label 178: @2617
     /* 2617 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2628), // Rule ID 214 //
     /* 2622 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2625 */   // Combiner Rule #153: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2625 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2628 */ // Label 179: @2628
     /* 2628 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2639), // Rule ID 236 //
     /* 2633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2636 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2639 */ // Label 180: @2639
     /* 2639 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2650), // Rule ID 282 //
     /* 2644 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2647 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2647 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2650 */ // Label 181: @2650
     /* 2650 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2661), // Rule ID 310 //
     /* 2655 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 2658 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2658 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2661 */ // Label 182: @2661
     /* 2661 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2672), // Rule ID 337 //
     /* 2666 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 2669 */   // Combiner Rule #192: match_ors; wip_match_opcode 'G_OR'
     /* 2669 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2672 */ // Label 183: @2672
     /* 2672 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2770), // Rule ID 155 //
     /* 2677 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2680 */   // MIs[0] root
     /* 2680 */   // No operand predicates
     /* 2680 */   // MIs[0] d1
     /* 2680 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2684 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2688 */   // MIs[1] p
     /* 2688 */   // No operand predicates
     /* 2688 */   // MIs[1] s1
     /* 2688 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2692 */   // MIs[1] Operand 3
     /* 2692 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2696 */   // MIs[0] d2
     /* 2696 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2700 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2704 */   // MIs[2] p
     /* 2704 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2709 */   // MIs[2] s2
     /* 2709 */   // No operand predicates
     /* 2709 */   // MIs[2] Operand 3
     /* 2709 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2713 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2717 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2719 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2722 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2735 */   // Combiner Rule #113: double_icmp_zero_or_combine
     /* 2735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2738 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2743 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2747 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2755 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2759 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2763 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2766 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2769 */   GIR_EraseRootFromParent_Done,
     /* 2770 */ // Label 184: @2770
     /* 2770 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2794), // Rule ID 114 //
     /* 2775 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2778 */   // MIs[0] dst
     /* 2778 */   // No operand predicates
     /* 2778 */   // MIs[0] src
     /* 2778 */   // No operand predicates
     /* 2778 */   // MIs[0] src
     /* 2778 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2783 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2788 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 2788 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2793 */   GIR_EraseRootFromParent_Done,
     /* 2794 */ // Label 185: @2794
     /* 2794 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2817), // Rule ID 105 //
     /* 2799 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 2802 */   // MIs[0] dst
     /* 2802 */   // No operand predicates
     /* 2802 */   // MIs[0] lhs
     /* 2802 */   // No operand predicates
     /* 2802 */   // MIs[0] Operand 2
     /* 2802 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2806 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2811 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 2811 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2816 */   GIR_EraseRootFromParent_Done,
     /* 2817 */ // Label 186: @2817
     /* 2817 */ GIM_Reject,
     /* 2818 */ // Label 10: @2818
     /* 2818 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2829), // Rule ID 95 //
     /* 2823 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 2826 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 2826 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 2829 */ // Label 187: @2829
     /* 2829 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2840), // Rule ID 143 //
     /* 2834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2837 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 2837 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2840 */ // Label 188: @2840
     /* 2840 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2851), // Rule ID 173 //
     /* 2845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 2848 */   // Combiner Rule #131: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 2848 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 2851 */ // Label 189: @2851
     /* 2851 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2862), // Rule ID 197 //
     /* 2856 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 2859 */   // Combiner Rule #147: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 2859 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 2862 */ // Label 190: @2862
     /* 2862 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2873), // Rule ID 239 //
     /* 2867 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2870 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 2870 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2873 */ // Label 191: @2873
     /* 2873 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2884), // Rule ID 283 //
     /* 2878 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2881 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 2881 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2884 */ // Label 192: @2884
     /* 2884 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2895), // Rule ID 311 //
     /* 2889 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 2892 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 2892 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2895 */ // Label 193: @2895
     /* 2895 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2918), // Rule ID 106 //
     /* 2900 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 2903 */   // MIs[0] dst
     /* 2903 */   // No operand predicates
     /* 2903 */   // MIs[0] lhs
     /* 2903 */   // No operand predicates
     /* 2903 */   // MIs[0] Operand 2
     /* 2903 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2907 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2912 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 2912 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2917 */   GIR_EraseRootFromParent_Done,
     /* 2918 */ // Label 194: @2918
     /* 2918 */ GIM_Reject,
     /* 2919 */ // Label 11: @2919
     /* 2919 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2930), // Rule ID 139 //
     /* 2924 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 2927 */   // Combiner Rule #101: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 2927 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 2930 */ // Label 195: @2930
     /* 2930 */ GIM_Reject,
     /* 2931 */ // Label 12: @2931
     /* 2931 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(2942), // Rule ID 347 //
     /* 2936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 2939 */   // Combiner Rule #202: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2939 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 2942 */ // Label 196: @2942
     /* 2942 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(2953), // Rule ID 348 //
     /* 2947 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 2950 */   // Combiner Rule #203: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2950 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 2953 */ // Label 197: @2953
     /* 2953 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(2964), // Rule ID 350 //
     /* 2958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 2961 */   // Combiner Rule #205: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 2964 */ // Label 198: @2964
     /* 2964 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(2975), // Rule ID 351 //
     /* 2969 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 2972 */   // Combiner Rule #206: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2972 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 2975 */ // Label 199: @2975
     /* 2975 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(2986), // Rule ID 352 //
     /* 2980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 2983 */   // Combiner Rule #207: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2983 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 2986 */ // Label 200: @2986
     /* 2986 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2997), // Rule ID 353 //
     /* 2991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 2994 */   // Combiner Rule #208: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 2997 */ // Label 201: @2997
     /* 2997 */ GIM_Reject,
     /* 2998 */ // Label 13: @2998
     /* 2998 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3009), // Rule ID 349 //
     /* 3003 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 3006 */   // Combiner Rule #204: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3006 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 3009 */ // Label 202: @3009
     /* 3009 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3071),
     /* 3014 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3017 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3038), // Rule ID 354 //
     /* 3022 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3025 */     // MIs[0] root
     /* 3025 */     // No operand predicates
     /* 3025 */     // MIs[0] x
     /* 3025 */     // No operand predicates
     /* 3025 */     // MIs[0] undef
     /* 3025 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3035 */     // Combiner Rule #209: merge_of_x_and_undef
     /* 3035 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3038 */   // Label 204: @3038
     /* 3038 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3070), // Rule ID 355 //
     /* 3043 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3046 */     // MIs[0] root
     /* 3046 */     // No operand predicates
     /* 3046 */     // MIs[0] x
     /* 3046 */     // No operand predicates
     /* 3046 */     // MIs[0] zero
     /* 3046 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3054 */     // MIs[1] Operand 1
     /* 3054 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3067 */     // Combiner Rule #210: merge_of_x_and_zero
     /* 3067 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3070 */   // Label 205: @3070
     /* 3070 */   GIM_Reject,
     /* 3071 */ // Label 203: @3071
     /* 3071 */ GIM_Reject,
     /* 3072 */ // Label 14: @3072
     /* 3072 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3083), // Rule ID 68 //
     /* 3077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 3080 */   // Combiner Rule #66: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3080 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 3083 */ // Label 206: @3083
     /* 3083 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3094), // Rule ID 97 //
     /* 3088 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3091 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3091 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3094 */ // Label 207: @3094
     /* 3094 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3105), // Rule ID 132 //
     /* 3099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3102 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3105 */ // Label 208: @3105
     /* 3105 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3119), // Rule ID 346 //
     /* 3110 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 3113 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3116 */   // MIs[0] dst
     /* 3116 */   // No operand predicates
     /* 3116 */   // MIs[0] unused
     /* 3116 */   // No operand predicates
     /* 3116 */   // Combiner Rule #201: combine_use_vector_truncate
     /* 3116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 3119 */ // Label 209: @3119
     /* 3119 */ GIM_Reject,
     /* 3120 */ // Label 15: @3120
     /* 3120 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3131), // Rule ID 131 //
     /* 3125 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3128 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3128 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3131 */ // Label 210: @3131
     /* 3131 */ GIM_Reject,
     /* 3132 */ // Label 16: @3132
     /* 3132 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3143), // Rule ID 339 //
     /* 3137 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 3140 */   // Combiner Rule #194: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3140 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 3143 */ // Label 211: @3143
     /* 3143 */ GIM_Reject,
     /* 3144 */ // Label 17: @3144
     /* 3144 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3165), // Rule ID 124 //
     /* 3149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3152 */   // MIs[0] dst
     /* 3152 */   // No operand predicates
     /* 3152 */   // MIs[0] t
     /* 3152 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3156 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3160 */   // MIs[1] ptr
     /* 3160 */   // No operand predicates
     /* 3160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3162 */   // Combiner Rule #88: i2p_to_p2i
     /* 3162 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3165 */ // Label 212: @3165
     /* 3165 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3186), // Rule ID 89 //
     /* 3170 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3173 */   // MIs[0] dst
     /* 3173 */   // No operand predicates
     /* 3173 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3173 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3177 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3183 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3183 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3186 */ // Label 213: @3186
     /* 3186 */ GIM_Reject,
     /* 3187 */ // Label 18: @3187
     /* 3187 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3198), // Rule ID 123 //
     /* 3192 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3195 */   // Combiner Rule #87: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3195 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 3198 */ // Label 214: @3198
     /* 3198 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3219), // Rule ID 90 //
     /* 3203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3206 */   // MIs[0] dst
     /* 3206 */   // No operand predicates
     /* 3206 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3206 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3216 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3216 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3219 */ // Label 215: @3219
     /* 3219 */ GIM_Reject,
     /* 3220 */ // Label 19: @3220
     /* 3220 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3241), // Rule ID 135 //
     /* 3225 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3228 */   // MIs[0] dst
     /* 3228 */   // No operand predicates
     /* 3228 */   // MIs[0] src1
     /* 3228 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3236 */   // MIs[1] src0
     /* 3236 */   // No operand predicates
     /* 3236 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3238 */   // Combiner Rule #97: bitcast_bitcast_fold
     /* 3238 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3241 */ // Label 216: @3241
     /* 3241 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3262), // Rule ID 87 //
     /* 3246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3249 */   // MIs[0] dst
     /* 3249 */   // No operand predicates
     /* 3249 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3249 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3257 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3259 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3259 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3262 */ // Label 217: @3262
     /* 3262 */ GIM_Reject,
     /* 3263 */ // Label 20: @3263
     /* 3263 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3292), // Rule ID 18 //
     /* 3268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3271 */   // MIs[0] dst
     /* 3271 */   // No operand predicates
     /* 3271 */   // MIs[0] src
     /* 3271 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3279 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3279 */   // No operand predicates
     /* 3279 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3286 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3286 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3291 */   GIR_EraseRootFromParent_Done,
     /* 3292 */ // Label 218: @3292
     /* 3292 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3315), // Rule ID 43 //
     /* 3297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3300 */   // MIs[0] root
     /* 3300 */   // No operand predicates
     /* 3300 */   // MIs[0] src
     /* 3300 */   // No operand predicates
     /* 3300 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3304 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3309 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3309 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3314 */   GIR_EraseRootFromParent_Done,
     /* 3315 */ // Label 219: @3315
     /* 3315 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3326), // Rule ID 44 //
     /* 3320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3323 */   // MIs[0] dst
     /* 3323 */   // No operand predicates
     /* 3323 */   // MIs[0] src
     /* 3323 */   // No operand predicates
     /* 3323 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3326 */ // Label 220: @3326
     /* 3326 */ GIM_Reject,
     /* 3327 */ // Label 21: @3327
     /* 3327 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3338), // Rule ID 69 //
     /* 3332 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3335 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3335 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3338 */ // Label 221: @3338
     /* 3338 */ GIM_Reject,
     /* 3339 */ // Label 22: @3339
     /* 3339 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3350), // Rule ID 70 //
     /* 3344 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3347 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3347 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3350 */ // Label 222: @3350
     /* 3350 */ GIM_Reject,
     /* 3351 */ // Label 23: @3351
     /* 3351 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3362), // Rule ID 71 //
     /* 3356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3359 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3362 */ // Label 223: @3362
     /* 3362 */ GIM_Reject,
     /* 3363 */ // Label 24: @3363
     /* 3363 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3374), // Rule ID 99 //
     /* 3368 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 3371 */   // Combiner Rule #80: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 3374 */ // Label 224: @3374
     /* 3374 */ GIM_Reject,
     /* 3375 */ // Label 25: @3375
     /* 3375 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3386), // Rule ID 125 //
     /* 3380 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3383 */   // Combiner Rule #89: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3383 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3386 */ // Label 225: @3386
     /* 3386 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3397), // Rule ID 256 //
     /* 3391 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 3394 */   // Combiner Rule #168: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3394 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 3397 */ // Label 226: @3397
     /* 3397 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3418), // Rule ID 56 //
     /* 3402 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 3405 */   // MIs[0] root
     /* 3405 */   // No operand predicates
     /* 3405 */   // MIs[0] select
     /* 3405 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3413 */   // MIs[1] cond
     /* 3413 */   // No operand predicates
     /* 3413 */   // MIs[1] true
     /* 3413 */   // No operand predicates
     /* 3413 */   // MIs[1] false
     /* 3413 */   // No operand predicates
     /* 3413 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3415 */   // Combiner Rule #54: select_of_anyext
     /* 3415 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3418 */ // Label 227: @3418
     /* 3418 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3439), // Rule ID 52 //
     /* 3423 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3426 */   // MIs[0] root
     /* 3426 */   // No operand predicates
     /* 3426 */   // MIs[0] second
     /* 3426 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3430 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3434 */   // MIs[1] src
     /* 3434 */   // No operand predicates
     /* 3434 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3436 */   // Combiner Rule #50: anyext_of_anyext
     /* 3436 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3439 */ // Label 228: @3439
     /* 3439 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3460), // Rule ID 54 //
     /* 3444 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3447 */   // MIs[0] root
     /* 3447 */   // No operand predicates
     /* 3447 */   // MIs[0] second
     /* 3447 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3455 */   // MIs[1] src
     /* 3455 */   // No operand predicates
     /* 3455 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3457 */   // Combiner Rule #52: anyext_of_sext
     /* 3457 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3460 */ // Label 229: @3460
     /* 3460 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3481), // Rule ID 53 //
     /* 3465 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3468 */   // MIs[0] root
     /* 3468 */   // No operand predicates
     /* 3468 */   // MIs[0] second
     /* 3468 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3476 */   // MIs[1] src
     /* 3476 */   // No operand predicates
     /* 3476 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3478 */   // Combiner Rule #51: anyext_of_zext
     /* 3478 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3481 */ // Label 230: @3481
     /* 3481 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3502), // Rule ID 88 //
     /* 3486 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3489 */   // MIs[0] dst
     /* 3489 */   // No operand predicates
     /* 3489 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3489 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3493 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3499 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3499 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3502 */ // Label 231: @3502
     /* 3502 */ GIM_Reject,
     /* 3503 */ // Label 26: @3503
     /* 3503 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3514), // Rule ID 133 //
     /* 3508 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3511 */   // Combiner Rule #95: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3511 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3514 */ // Label 232: @3514
     /* 3514 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3525), // Rule ID 134 //
     /* 3519 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3522 */   // Combiner Rule #96: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3522 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3525 */ // Label 233: @3525
     /* 3525 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3536), // Rule ID 172 //
     /* 3530 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 3533 */   // Combiner Rule #130: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3533 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 3536 */ // Label 234: @3536
     /* 3536 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3557), // Rule ID 57 //
     /* 3541 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3544 */   // MIs[0] root
     /* 3544 */   // No operand predicates
     /* 3544 */   // MIs[0] select
     /* 3544 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3548 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3552 */   // MIs[1] cond
     /* 3552 */   // No operand predicates
     /* 3552 */   // MIs[1] true
     /* 3552 */   // No operand predicates
     /* 3552 */   // MIs[1] false
     /* 3552 */   // No operand predicates
     /* 3552 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3554 */   // Combiner Rule #55: select_of_truncate
     /* 3554 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3557 */ // Label 235: @3557
     /* 3557 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3586), // Rule ID 59 //
     /* 3562 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 3565 */   // MIs[0] root
     /* 3565 */   // No operand predicates
     /* 3565 */   // MIs[0] binop
     /* 3565 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3573 */   // MIs[1] x
     /* 3573 */   // No operand predicates
     /* 3573 */   // MIs[1] const
     /* 3573 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3577 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3581 */   // MIs[2] imm
     /* 3581 */   // No operand predicates
     /* 3581 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3583 */   // Combiner Rule #57: narrow_binop_add
     /* 3583 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3586 */ // Label 236: @3586
     /* 3586 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3615), // Rule ID 62 //
     /* 3591 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3594 */   // MIs[0] root
     /* 3594 */   // No operand predicates
     /* 3594 */   // MIs[0] binop
     /* 3594 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3598 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3602 */   // MIs[1] x
     /* 3602 */   // No operand predicates
     /* 3602 */   // MIs[1] const
     /* 3602 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3606 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3610 */   // MIs[2] imm
     /* 3610 */   // No operand predicates
     /* 3610 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3612 */   // Combiner Rule #60: narrow_binop_and
     /* 3612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3615 */ // Label 237: @3615
     /* 3615 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3644), // Rule ID 61 //
     /* 3620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3623 */   // MIs[0] root
     /* 3623 */   // No operand predicates
     /* 3623 */   // MIs[0] binop
     /* 3623 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3627 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3631 */   // MIs[1] x
     /* 3631 */   // No operand predicates
     /* 3631 */   // MIs[1] const
     /* 3631 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3635 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3639 */   // MIs[2] imm
     /* 3639 */   // No operand predicates
     /* 3639 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3641 */   // Combiner Rule #59: narrow_binop_mul
     /* 3641 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3644 */ // Label 238: @3644
     /* 3644 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3673), // Rule ID 63 //
     /* 3649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3652 */   // MIs[0] root
     /* 3652 */   // No operand predicates
     /* 3652 */   // MIs[0] binop
     /* 3652 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3660 */   // MIs[1] x
     /* 3660 */   // No operand predicates
     /* 3660 */   // MIs[1] const
     /* 3660 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3664 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3668 */   // MIs[2] imm
     /* 3668 */   // No operand predicates
     /* 3668 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3670 */   // Combiner Rule #61: narrow_binop_or
     /* 3670 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3673 */ // Label 239: @3673
     /* 3673 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3702), // Rule ID 60 //
     /* 3678 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3681 */   // MIs[0] root
     /* 3681 */   // No operand predicates
     /* 3681 */   // MIs[0] binop
     /* 3681 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3689 */   // MIs[1] x
     /* 3689 */   // No operand predicates
     /* 3689 */   // MIs[1] const
     /* 3689 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3693 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3697 */   // MIs[2] imm
     /* 3697 */   // No operand predicates
     /* 3697 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3699 */   // Combiner Rule #58: narrow_binop_sub
     /* 3699 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3702 */ // Label 240: @3702
     /* 3702 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3731), // Rule ID 64 //
     /* 3707 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3710 */   // MIs[0] root
     /* 3710 */   // No operand predicates
     /* 3710 */   // MIs[0] binop
     /* 3710 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3718 */   // MIs[1] x
     /* 3718 */   // No operand predicates
     /* 3718 */   // MIs[1] const
     /* 3718 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3722 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3726 */   // MIs[2] imm
     /* 3726 */   // No operand predicates
     /* 3726 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3728 */   // Combiner Rule #62: narrow_binop_xor
     /* 3728 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3731 */ // Label 241: @3731
     /* 3731 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3752), // Rule ID 47 //
     /* 3736 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 3739 */   // MIs[0] root
     /* 3739 */   // No operand predicates
     /* 3739 */   // MIs[0] ext
     /* 3739 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3747 */   // MIs[1] src
     /* 3747 */   // No operand predicates
     /* 3747 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3749 */   // Combiner Rule #45: truncate_of_anyext
     /* 3749 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3752 */ // Label 242: @3752
     /* 3752 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3776), // Rule ID 58 //
     /* 3757 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3760 */   // MIs[0] root
     /* 3760 */   // No operand predicates
     /* 3760 */   // MIs[0] bv
     /* 3760 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 3768 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 3771 */   // MIs[1] unused
     /* 3771 */   // No operand predicates
     /* 3771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3773 */   // Combiner Rule #56: buildvector_of_truncate
     /* 3773 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3776 */ // Label 243: @3776
     /* 3776 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3797), // Rule ID 46 //
     /* 3781 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 3784 */   // MIs[0] root
     /* 3784 */   // No operand predicates
     /* 3784 */   // MIs[0] ext
     /* 3784 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3788 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3792 */   // MIs[1] src
     /* 3792 */   // No operand predicates
     /* 3792 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3794 */   // Combiner Rule #44: truncate_of_sext
     /* 3794 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3797 */ // Label 244: @3797
     /* 3797 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3818), // Rule ID 45 //
     /* 3802 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 3805 */   // MIs[0] root
     /* 3805 */   // No operand predicates
     /* 3805 */   // MIs[0] ext
     /* 3805 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3813 */   // MIs[1] src
     /* 3813 */   // No operand predicates
     /* 3813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3815 */   // Combiner Rule #43: truncate_of_zext
     /* 3815 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3818 */ // Label 245: @3818
     /* 3818 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3839), // Rule ID 86 //
     /* 3823 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3826 */   // MIs[0] dst
     /* 3826 */   // No operand predicates
     /* 3826 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3826 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3830 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3836 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 3836 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3839 */ // Label 246: @3839
     /* 3839 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3860), // Rule ID 65 //
     /* 3844 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 3847 */   // MIs[0] root
     /* 3847 */   // No operand predicates
     /* 3847 */   // MIs[0] int
     /* 3847 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3855 */   // MIs[1] imm
     /* 3855 */   // No operand predicates
     /* 3855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3857 */   // Combiner Rule #63: integer_of_truncate
     /* 3857 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3860 */ // Label 247: @3860
     /* 3860 */ GIM_Reject,
     /* 3861 */ // Label 27: @3861
     /* 3861 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3872), // Rule ID 255 //
     /* 3866 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 3869 */   // Combiner Rule #168: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 3869 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 3872 */ // Label 248: @3872
     /* 3872 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3893), // Rule ID 51 //
     /* 3877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3880 */   // MIs[0] root
     /* 3880 */   // No operand predicates
     /* 3880 */   // MIs[0] second
     /* 3880 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3884 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3888 */   // MIs[1] src
     /* 3888 */   // No operand predicates
     /* 3888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3890 */   // Combiner Rule #49: sext_of_anyext
     /* 3890 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3893 */ // Label 249: @3893
     /* 3893 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(3914), // Rule ID 50 //
     /* 3898 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3901 */   // MIs[0] root
     /* 3901 */   // No operand predicates
     /* 3901 */   // MIs[0] second
     /* 3901 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3909 */   // MIs[1] src
     /* 3909 */   // No operand predicates
     /* 3909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3911 */   // Combiner Rule #48: sext_of_sext
     /* 3911 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3914 */ // Label 250: @3914
     /* 3914 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(3935), // Rule ID 340 //
     /* 3919 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 3922 */   // MIs[0] root
     /* 3922 */   // No operand predicates
     /* 3922 */   // MIs[0] src
     /* 3922 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 3930 */   // MIs[1] x
     /* 3930 */   // No operand predicates
     /* 3930 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3932 */   // Combiner Rule #195: sext_trunc
     /* 3932 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3935 */ // Label 251: @3935
     /* 3935 */ GIM_Reject,
     /* 3936 */ // Label 28: @3936
     /* 3936 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(3947), // Rule ID 159 //
     /* 3941 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 3944 */   // Combiner Rule #117: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 3944 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 3947 */ // Label 252: @3947
     /* 3947 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(3958), // Rule ID 167 //
     /* 3952 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 3955 */   // Combiner Rule #125: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3955 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 3958 */ // Label 253: @3958
     /* 3958 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(3969), // Rule ID 224 //
     /* 3963 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 3966 */   // Combiner Rule #161: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 3969 */ // Label 254: @3969
     /* 3969 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(3980), // Rule ID 171 //
     /* 3974 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 3977 */   // MIs[0] dst
     /* 3977 */   // No operand predicates
     /* 3977 */   // MIs[0] src
     /* 3977 */   // No operand predicates
     /* 3977 */   // MIs[0] imm
     /* 3977 */   // No operand predicates
     /* 3977 */   // Combiner Rule #129: sext_inreg_to_zext_inreg
     /* 3977 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 3980 */ // Label 255: @3980
     /* 3980 */ GIM_Reject,
     /* 3981 */ // Label 29: @3981
     /* 3981 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(3992), // Rule ID 170 //
     /* 3986 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 3989 */   // Combiner Rule #128: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 3989 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 3992 */ // Label 256: @3992
     /* 3992 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4003), // Rule ID 254 //
     /* 3997 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 4000 */   // Combiner Rule #168: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4000 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 4003 */ // Label 257: @4003
     /* 4003 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4024), // Rule ID 55 //
     /* 4008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4011 */   // MIs[0] root
     /* 4011 */   // No operand predicates
     /* 4011 */   // MIs[0] select
     /* 4011 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4019 */   // MIs[1] cond
     /* 4019 */   // No operand predicates
     /* 4019 */   // MIs[1] true
     /* 4019 */   // No operand predicates
     /* 4019 */   // MIs[1] false
     /* 4019 */   // No operand predicates
     /* 4019 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4021 */   // Combiner Rule #53: select_of_zext
     /* 4021 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4024 */ // Label 258: @4024
     /* 4024 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4045), // Rule ID 49 //
     /* 4029 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4032 */   // MIs[0] root
     /* 4032 */   // No operand predicates
     /* 4032 */   // MIs[0] second
     /* 4032 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4040 */   // MIs[1] src
     /* 4040 */   // No operand predicates
     /* 4040 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4042 */   // Combiner Rule #47: zext_of_anyext
     /* 4042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4045 */ // Label 259: @4045
     /* 4045 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4072), // Rule ID 341 //
     /* 4050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 4053 */   // MIs[0] root
     /* 4053 */   // No operand predicates
     /* 4053 */   // MIs[0] src
     /* 4053 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4061 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4067 */   // MIs[1] x
     /* 4067 */   // No operand predicates
     /* 4067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4069 */   // Combiner Rule #196: zext_trunc
     /* 4069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 4072 */ // Label 260: @4072
     /* 4072 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4093), // Rule ID 48 //
     /* 4077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4080 */   // MIs[0] root
     /* 4080 */   // No operand predicates
     /* 4080 */   // MIs[0] second
     /* 4080 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4088 */   // MIs[1] src
     /* 4088 */   // No operand predicates
     /* 4088 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4090 */   // Combiner Rule #46: zext_of_zext
     /* 4090 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4093 */ // Label 261: @4093
     /* 4093 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4110), // Rule ID 342 //
     /* 4098 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 4101 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4107 */   // MIs[0] root
     /* 4107 */   // No operand predicates
     /* 4107 */   // MIs[0] x
     /* 4107 */   // No operand predicates
     /* 4107 */   // Combiner Rule #197: nneg_zext
     /* 4107 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4110 */ // Label 262: @4110
     /* 4110 */ GIM_Reject,
     /* 4111 */ // Label 30: @4111
     /* 4111 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4122), // Rule ID 79 //
     /* 4116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 4119 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 4122 */ // Label 263: @4122
     /* 4122 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4133), // Rule ID 82 //
     /* 4127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4130 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4133 */ // Label 264: @4133
     /* 4133 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4144), // Rule ID 115 //
     /* 4138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4141 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4144 */ // Label 265: @4144
     /* 4144 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4155), // Rule ID 199 //
     /* 4149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4152 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4155 */ // Label 266: @4155
     /* 4155 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4166), // Rule ID 204 //
     /* 4160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4163 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4163 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4166 */ // Label 267: @4166
     /* 4166 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4177), // Rule ID 223 //
     /* 4171 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 4174 */   // Combiner Rule #160: commute_shift; wip_match_opcode 'G_SHL'
     /* 4174 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4177 */ // Label 268: @4177
     /* 4177 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4188), // Rule ID 237 //
     /* 4182 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4185 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4185 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4188 */ // Label 269: @4188
     /* 4188 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4199), // Rule ID 290 //
     /* 4193 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 4196 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4196 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4199 */ // Label 270: @4199
     /* 4199 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4234), // Rule ID 41 //
     /* 4204 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4207 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4213 */   // MIs[0] root
     /* 4213 */   // No operand predicates
     /* 4213 */   // MIs[0] left
     /* 4213 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4221 */   // MIs[1] imm
     /* 4221 */   // No operand predicates
     /* 4221 */   // MIs[0] x
     /* 4221 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4225 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4229 */   // MIs[2] imm1
     /* 4229 */   // No operand predicates
     /* 4229 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4231 */   // Combiner Rule #39: shl_of_vscale
     /* 4231 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4234 */ // Label 271: @4234
     /* 4234 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4257), // Rule ID 107 //
     /* 4239 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4242 */   // MIs[0] dst
     /* 4242 */   // No operand predicates
     /* 4242 */   // MIs[0] lhs
     /* 4242 */   // No operand predicates
     /* 4242 */   // MIs[0] Operand 2
     /* 4242 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4246 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4251 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4251 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4256 */   GIR_EraseRootFromParent_Done,
     /* 4257 */ // Label 272: @4257
     /* 4257 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4268), // Rule ID 144 //
     /* 4262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4265 */   // MIs[0] root
     /* 4265 */   // No operand predicates
     /* 4265 */   // MIs[0] mi.shifted
     /* 4265 */   // No operand predicates
     /* 4265 */   // MIs[0] mi.amt
     /* 4265 */   // No operand predicates
     /* 4265 */   // Combiner Rule #104: shifts_too_big @ [mi[0]]
     /* 4265 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4268 */ // Label 273: @4268
     /* 4268 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4279), // Rule ID 160 //
     /* 4273 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 4276 */   // MIs[0] dst
     /* 4276 */   // No operand predicates
     /* 4276 */   // MIs[0] src0
     /* 4276 */   // No operand predicates
     /* 4276 */   // MIs[0] src1
     /* 4276 */   // No operand predicates
     /* 4276 */   // Combiner Rule #118: reduce_shl_of_extend
     /* 4276 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 4279 */ // Label 274: @4279
     /* 4279 */ GIM_Reject,
     /* 4280 */ // Label 31: @4280
     /* 4280 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4291), // Rule ID 84 //
     /* 4285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4288 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4288 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4291 */ // Label 275: @4291
     /* 4291 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4302), // Rule ID 116 //
     /* 4296 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4299 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4299 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4302 */ // Label 276: @4302
     /* 4302 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4313), // Rule ID 201 //
     /* 4307 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4310 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4310 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4313 */ // Label 277: @4313
     /* 4313 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4324), // Rule ID 206 //
     /* 4318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4321 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4321 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4324 */ // Label 278: @4324
     /* 4324 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4335), // Rule ID 227 //
     /* 4329 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4332 */   // Combiner Rule #163: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4332 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4335 */ // Label 279: @4335
     /* 4335 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4346), // Rule ID 229 //
     /* 4340 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4343 */   // Combiner Rule #164: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4343 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4346 */ // Label 280: @4346
     /* 4346 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4357), // Rule ID 234 //
     /* 4351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4354 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4354 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4357 */ // Label 281: @4357
     /* 4357 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4368), // Rule ID 288 //
     /* 4362 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 4365 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4365 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4368 */ // Label 282: @4368
     /* 4368 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4391), // Rule ID 109 //
     /* 4373 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4376 */   // MIs[0] dst
     /* 4376 */   // No operand predicates
     /* 4376 */   // MIs[0] lhs
     /* 4376 */   // No operand predicates
     /* 4376 */   // MIs[0] Operand 2
     /* 4376 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4380 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4385 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4385 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4390 */   GIR_EraseRootFromParent_Done,
     /* 4391 */ // Label 283: @4391
     /* 4391 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4402), // Rule ID 146 //
     /* 4396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4399 */   // MIs[0] root
     /* 4399 */   // No operand predicates
     /* 4399 */   // MIs[0] mi.shifted
     /* 4399 */   // No operand predicates
     /* 4399 */   // MIs[0] mi.amt
     /* 4399 */   // No operand predicates
     /* 4399 */   // Combiner Rule #104: shifts_too_big @ [mi[2]]
     /* 4399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4402 */ // Label 284: @4402
     /* 4402 */ GIM_Reject,
     /* 4403 */ // Label 32: @4403
     /* 4403 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4414), // Rule ID 83 //
     /* 4408 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4411 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4411 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4414 */ // Label 285: @4414
     /* 4414 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4425), // Rule ID 117 //
     /* 4419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4422 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4422 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4425 */ // Label 286: @4425
     /* 4425 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4436), // Rule ID 157 //
     /* 4430 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 4433 */   // Combiner Rule #115: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4433 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 4436 */ // Label 287: @4436
     /* 4436 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4447), // Rule ID 200 //
     /* 4441 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4444 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4444 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4447 */ // Label 288: @4447
     /* 4447 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4458), // Rule ID 205 //
     /* 4452 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4455 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4455 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4458 */ // Label 289: @4458
     /* 4458 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4469), // Rule ID 226 //
     /* 4463 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4466 */   // Combiner Rule #163: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4466 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4469 */ // Label 290: @4469
     /* 4469 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4480), // Rule ID 228 //
     /* 4474 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4477 */   // Combiner Rule #164: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4477 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4480 */ // Label 291: @4480
     /* 4480 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4491), // Rule ID 233 //
     /* 4485 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4488 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4488 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4491 */ // Label 292: @4491
     /* 4491 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4502), // Rule ID 289 //
     /* 4496 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 4499 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4499 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4502 */ // Label 293: @4502
     /* 4502 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4525), // Rule ID 108 //
     /* 4507 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4510 */   // MIs[0] dst
     /* 4510 */   // No operand predicates
     /* 4510 */   // MIs[0] lhs
     /* 4510 */   // No operand predicates
     /* 4510 */   // MIs[0] Operand 2
     /* 4510 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4514 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4519 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4519 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4524 */   GIR_EraseRootFromParent_Done,
     /* 4525 */ // Label 294: @4525
     /* 4525 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4536), // Rule ID 145 //
     /* 4530 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4533 */   // MIs[0] root
     /* 4533 */   // No operand predicates
     /* 4533 */   // MIs[0] mi.shifted
     /* 4533 */   // No operand predicates
     /* 4533 */   // MIs[0] mi.amt
     /* 4533 */   // No operand predicates
     /* 4533 */   // Combiner Rule #104: shifts_too_big @ [mi[1]]
     /* 4533 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4536 */ // Label 295: @4536
     /* 4536 */ GIM_Reject,
     /* 4537 */ // Label 33: @4537
     /* 4537 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4548), // Rule ID 215 //
     /* 4542 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 4545 */   // Combiner Rule #154: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4545 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4548 */ // Label 296: @4548
     /* 4548 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4559), // Rule ID 219 //
     /* 4553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4556 */   // Combiner Rule #157: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4556 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4559 */ // Label 297: @4559
     /* 4559 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4579), // Rule ID 218 //
     /* 4564 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4567 */   // MIs[0] x
     /* 4567 */   // No operand predicates
     /* 4567 */   // MIs[0] y
     /* 4567 */   // No operand predicates
     /* 4567 */   // MIs[0] z
     /* 4567 */   // No operand predicates
     /* 4567 */   // MIs[0] Operand 3
     /* 4567 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4571 */   // Combiner Rule #156: funnel_shift_left_zero
     /* 4571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4574 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4576 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4578 */   GIR_EraseRootFromParent_Done,
     /* 4579 */ // Label 298: @4579
     /* 4579 */ GIM_Reject,
     /* 4580 */ // Label 34: @4580
     /* 4580 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4591), // Rule ID 216 //
     /* 4585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 4588 */   // Combiner Rule #154: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4588 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4591 */ // Label 299: @4591
     /* 4591 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4602), // Rule ID 220 //
     /* 4596 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4599 */   // Combiner Rule #157: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4599 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4602 */ // Label 300: @4602
     /* 4602 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4622), // Rule ID 217 //
     /* 4607 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4610 */   // MIs[0] x
     /* 4610 */   // No operand predicates
     /* 4610 */   // MIs[0] y
     /* 4610 */   // No operand predicates
     /* 4610 */   // MIs[0] z
     /* 4610 */   // No operand predicates
     /* 4610 */   // MIs[0] Operand 3
     /* 4610 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4614 */   // Combiner Rule #155: funnel_shift_right_zero
     /* 4614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4617 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4619 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4621 */   GIR_EraseRootFromParent_Done,
     /* 4622 */ // Label 301: @4622
     /* 4622 */ GIM_Reject,
     /* 4623 */ // Label 35: @4623
     /* 4623 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4646), // Rule ID 112 //
     /* 4628 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4631 */   // MIs[0] dst
     /* 4631 */   // No operand predicates
     /* 4631 */   // MIs[0] lhs
     /* 4631 */   // No operand predicates
     /* 4631 */   // MIs[0] Operand 2
     /* 4631 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4635 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4640 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4640 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4645 */   GIR_EraseRootFromParent_Done,
     /* 4646 */ // Label 302: @4646
     /* 4646 */ GIM_Reject,
     /* 4647 */ // Label 36: @4647
     /* 4647 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4670), // Rule ID 111 //
     /* 4652 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4655 */   // MIs[0] dst
     /* 4655 */   // No operand predicates
     /* 4655 */   // MIs[0] lhs
     /* 4655 */   // No operand predicates
     /* 4655 */   // MIs[0] Operand 2
     /* 4655 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4659 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4664 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4664 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4669 */   GIR_EraseRootFromParent_Done,
     /* 4670 */ // Label 303: @4670
     /* 4670 */ GIM_Reject,
     /* 4671 */ // Label 37: @4671
     /* 4671 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4682), // Rule ID 152 //
     /* 4676 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 4679 */   // Combiner Rule #110: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 4679 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 4682 */ // Label 304: @4682
     /* 4682 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4693), // Rule ID 153 //
     /* 4687 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 4690 */   // Combiner Rule #111: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 4690 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 4693 */ // Label 305: @4693
     /* 4693 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4704), // Rule ID 156 //
     /* 4698 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 4701 */   // Combiner Rule #114: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 4701 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 4704 */ // Label 306: @4704
     /* 4704 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4715), // Rule ID 150 //
     /* 4709 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 4712 */   // MIs[0] root
     /* 4712 */   // No operand predicates
     /* 4712 */   // MIs[0] pred
     /* 4712 */   // No operand predicates
     /* 4712 */   // MIs[0] lhs
     /* 4712 */   // No operand predicates
     /* 4712 */   // MIs[0] rhs
     /* 4712 */   // No operand predicates
     /* 4712 */   // Combiner Rule #108: canonicalize_icmp
     /* 4712 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 4715 */ // Label 307: @4715
     /* 4715 */ GIM_Reject,
     /* 4716 */ // Label 38: @4716
     /* 4716 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4727), // Rule ID 151 //
     /* 4721 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 4724 */   // MIs[0] root
     /* 4724 */   // No operand predicates
     /* 4724 */   // MIs[0] pred
     /* 4724 */   // No operand predicates
     /* 4724 */   // MIs[0] lhs
     /* 4724 */   // No operand predicates
     /* 4724 */   // MIs[0] rhs
     /* 4724 */   // No operand predicates
     /* 4724 */   // Combiner Rule #109: canonicalize_fcmp
     /* 4724 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 4727 */ // Label 308: @4727
     /* 4727 */ GIM_Reject,
     /* 4728 */ // Label 39: @4728
     /* 4728 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4739), // Rule ID 102 //
     /* 4733 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 4736 */   // Combiner Rule #82: select_same_val; wip_match_opcode 'G_SELECT'
     /* 4736 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 4739 */ // Label 309: @4739
     /* 4739 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4750), // Rule ID 163 //
     /* 4744 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 4747 */   // Combiner Rule #121: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 4747 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 4750 */ // Label 310: @4750
     /* 4750 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4761), // Rule ID 165 //
     /* 4755 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 4758 */   // Combiner Rule #123: match_selects; wip_match_opcode 'G_SELECT'
     /* 4758 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 4761 */ // Label 311: @4761
     /* 4761 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4772), // Rule ID 305 //
     /* 4766 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 4769 */   // Combiner Rule #187: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 4769 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 4772 */ // Label 312: @4772
     /* 4772 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4793), // Rule ID 164 //
     /* 4777 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 4780 */   // MIs[0] root
     /* 4780 */   // No operand predicates
     /* 4780 */   // MIs[0] tst
     /* 4780 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4784 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 4788 */   // MIs[1] tst1
     /* 4788 */   // No operand predicates
     /* 4788 */   // MIs[1] a
     /* 4788 */   // No operand predicates
     /* 4788 */   // MIs[1] b
     /* 4788 */   // No operand predicates
     /* 4788 */   // MIs[0] x
     /* 4788 */   // No operand predicates
     /* 4788 */   // MIs[0] y
     /* 4788 */   // No operand predicates
     /* 4788 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4790 */   // Combiner Rule #122: select_to_iminmax
     /* 4790 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 4793 */ // Label 313: @4793
     /* 4793 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(4822), // Rule ID 162 //
     /* 4798 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 4801 */   // MIs[0] dst
     /* 4801 */   // No operand predicates
     /* 4801 */   // MIs[0] undef
     /* 4801 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4809 */   // MIs[0] x
     /* 4809 */   // No operand predicates
     /* 4809 */   // MIs[0] y
     /* 4809 */   // No operand predicates
     /* 4809 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4814 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4816 */   // Combiner Rule #120: select_undef_cmp
     /* 4816 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4821 */   GIR_EraseRootFromParent_Done,
     /* 4822 */ // Label 314: @4822
     /* 4822 */ GIM_Reject,
     /* 4823 */ // Label 40: @4823
     /* 4823 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(4834), // Rule ID 316 //
     /* 4828 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 4831 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 4831 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4834 */ // Label 315: @4834
     /* 4834 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(4845), // Rule ID 357 //
     /* 4839 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 4842 */   // Combiner Rule #211: match_addos; wip_match_opcode 'G_UADDO'
     /* 4842 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 4845 */ // Label 316: @4845
     /* 4845 */ GIM_Reject,
     /* 4846 */ // Label 41: @4846
     /* 4846 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(4857), // Rule ID 188 //
     /* 4851 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 4854 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 4854 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4857 */ // Label 317: @4857
     /* 4857 */ GIM_Reject,
     /* 4858 */ // Label 42: @4858
     /* 4858 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(4869), // Rule ID 359 //
     /* 4863 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 4866 */   // Combiner Rule #212: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 4866 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4869 */ // Label 318: @4869
     /* 4869 */ GIM_Reject,
     /* 4870 */ // Label 43: @4870
     /* 4870 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(4881), // Rule ID 190 //
     /* 4875 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 4878 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 4878 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4881 */ // Label 319: @4881
     /* 4881 */ GIM_Reject,
     /* 4882 */ // Label 44: @4882
     /* 4882 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(4893), // Rule ID 317 //
     /* 4887 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 4890 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 4890 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4893 */ // Label 320: @4893
     /* 4893 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(4904), // Rule ID 356 //
     /* 4898 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 4901 */   // Combiner Rule #211: match_addos; wip_match_opcode 'G_SADDO'
     /* 4901 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 4904 */ // Label 321: @4904
     /* 4904 */ GIM_Reject,
     /* 4905 */ // Label 45: @4905
     /* 4905 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(4916), // Rule ID 189 //
     /* 4910 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 4913 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 4913 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4916 */ // Label 322: @4916
     /* 4916 */ GIM_Reject,
     /* 4917 */ // Label 46: @4917
     /* 4917 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(4928), // Rule ID 358 //
     /* 4922 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 4925 */   // Combiner Rule #212: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 4925 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4928 */ // Label 323: @4928
     /* 4928 */ GIM_Reject,
     /* 4929 */ // Label 47: @4929
     /* 4929 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(4940), // Rule ID 191 //
     /* 4934 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 4937 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 4937 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4940 */ // Label 324: @4940
     /* 4940 */ GIM_Reject,
     /* 4941 */ // Label 48: @4941
     /* 4941 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(4952), // Rule ID 184 //
     /* 4946 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 4949 */   // Combiner Rule #142: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 4949 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 4952 */ // Label 325: @4952
     /* 4952 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(4963), // Rule ID 186 //
     /* 4957 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 4960 */   // Combiner Rule #143: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 4960 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 4963 */ // Label 326: @4963
     /* 4963 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(4974), // Rule ID 318 //
     /* 4968 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 4971 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 4971 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4974 */ // Label 327: @4974
     /* 4974 */ GIM_Reject,
     /* 4975 */ // Label 49: @4975
     /* 4975 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(4986), // Rule ID 185 //
     /* 4980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 4983 */   // Combiner Rule #142: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 4983 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 4986 */ // Label 328: @4986
     /* 4986 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(4997), // Rule ID 187 //
     /* 4991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 4994 */   // Combiner Rule #143: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 4994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 4997 */ // Label 329: @4997
     /* 4997 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5008), // Rule ID 319 //
     /* 5002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5005 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5005 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5008 */ // Label 330: @5008
     /* 5008 */ GIM_Reject,
     /* 5009 */ // Label 50: @5009
     /* 5009 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5020), // Rule ID 262 //
     /* 5014 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5017 */   // Combiner Rule #174: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5017 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 5020 */ // Label 331: @5020
     /* 5020 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5031), // Rule ID 320 //
     /* 5025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5028 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5028 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5031 */ // Label 332: @5031
     /* 5031 */ GIM_Reject,
     /* 5032 */ // Label 51: @5032
     /* 5032 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5043), // Rule ID 321 //
     /* 5037 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5040 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5040 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5043 */ // Label 333: @5043
     /* 5043 */ GIM_Reject,
     /* 5044 */ // Label 52: @5044
     /* 5044 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5055), // Rule ID 322 //
     /* 5049 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5052 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5052 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5055 */ // Label 334: @5055
     /* 5055 */ GIM_Reject,
     /* 5056 */ // Label 53: @5056
     /* 5056 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5067), // Rule ID 323 //
     /* 5061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5064 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5064 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5067 */ // Label 335: @5067
     /* 5067 */ GIM_Reject,
     /* 5068 */ // Label 54: @5068
     /* 5068 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5079), // Rule ID 203 //
     /* 5073 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5076 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5076 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5079 */ // Label 336: @5079
     /* 5079 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5090), // Rule ID 207 //
     /* 5084 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5087 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5087 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5090 */ // Label 337: @5090
     /* 5090 */ GIM_Reject,
     /* 5091 */ // Label 55: @5091
     /* 5091 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5102), // Rule ID 202 //
     /* 5096 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5099 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5099 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5102 */ // Label 338: @5102
     /* 5102 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5113), // Rule ID 208 //
     /* 5107 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5110 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5110 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5113 */ // Label 339: @5113
     /* 5113 */ GIM_Reject,
     /* 5114 */ // Label 56: @5114
     /* 5114 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5125), // Rule ID 324 //
     /* 5119 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5122 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5122 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5125 */ // Label 340: @5125
     /* 5125 */ GIM_Reject,
     /* 5126 */ // Label 57: @5126
     /* 5126 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5137), // Rule ID 325 //
     /* 5131 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5134 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5134 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5137 */ // Label 341: @5137
     /* 5137 */ GIM_Reject,
     /* 5138 */ // Label 58: @5138
     /* 5138 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5149), // Rule ID 326 //
     /* 5143 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5146 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5146 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5149 */ // Label 342: @5149
     /* 5149 */ GIM_Reject,
     /* 5150 */ // Label 59: @5150
     /* 5150 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5161), // Rule ID 327 //
     /* 5155 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5158 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5158 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5161 */ // Label 343: @5161
     /* 5161 */ GIM_Reject,
     /* 5162 */ // Label 60: @5162
     /* 5162 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5173), // Rule ID 248 //
     /* 5167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5170 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5170 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5173 */ // Label 344: @5173
     /* 5173 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5184), // Rule ID 263 //
     /* 5178 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5181 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5181 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5184 */ // Label 345: @5184
     /* 5184 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5195), // Rule ID 270 //
     /* 5189 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 5192 */   // Combiner Rule #177: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5192 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 5195 */ // Label 346: @5195
     /* 5195 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5206), // Rule ID 271 //
     /* 5200 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5203 */   // Combiner Rule #178: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5203 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5206 */ // Label 347: @5206
     /* 5206 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5217), // Rule ID 272 //
     /* 5211 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5214 */   // Combiner Rule #179: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5214 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5217 */ // Label 348: @5217
     /* 5217 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5228), // Rule ID 273 //
     /* 5222 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5225 */   // Combiner Rule #180: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5225 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5228 */ // Label 349: @5228
     /* 5228 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5239), // Rule ID 296 //
     /* 5233 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5236 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5236 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5239 */ // Label 350: @5239
     /* 5239 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5250), // Rule ID 328 //
     /* 5244 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5247 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5247 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5250 */ // Label 351: @5250
     /* 5250 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5273), // Rule ID 137 //
     /* 5255 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5258 */   // MIs[0] dst
     /* 5258 */   // No operand predicates
     /* 5258 */   // MIs[0] x
     /* 5258 */   // No operand predicates
     /* 5258 */   // MIs[0] y
     /* 5258 */   // No operand predicates
     /* 5258 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5262 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5267 */   // Combiner Rule #99: right_identity_neg_zero_fp
     /* 5267 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5272 */   GIR_EraseRootFromParent_Done,
     /* 5273 */ // Label 352: @5273
     /* 5273 */ GIM_Reject,
     /* 5274 */ // Label 61: @5274
     /* 5274 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5285), // Rule ID 249 //
     /* 5279 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5282 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5282 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5285 */ // Label 353: @5285
     /* 5285 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5296), // Rule ID 264 //
     /* 5290 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5293 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5293 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5296 */ // Label 354: @5296
     /* 5296 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5307), // Rule ID 274 //
     /* 5301 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5304 */   // Combiner Rule #181: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5304 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5307 */ // Label 355: @5307
     /* 5307 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5318), // Rule ID 275 //
     /* 5312 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5315 */   // Combiner Rule #182: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5315 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5318 */ // Label 356: @5318
     /* 5318 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5329), // Rule ID 276 //
     /* 5323 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5326 */   // Combiner Rule #183: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5326 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5329 */ // Label 357: @5329
     /* 5329 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5340), // Rule ID 277 //
     /* 5334 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5337 */   // Combiner Rule #184: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5337 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5340 */ // Label 358: @5340
     /* 5340 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5351), // Rule ID 297 //
     /* 5345 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5348 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5348 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5351 */ // Label 359: @5351
     /* 5351 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5362), // Rule ID 306 //
     /* 5356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5359 */   // Combiner Rule #188: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 5362 */ // Label 360: @5362
     /* 5362 */ GIM_Reject,
     /* 5363 */ // Label 62: @5363
     /* 5363 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5374), // Rule ID 250 //
     /* 5368 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5371 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5374 */ // Label 361: @5374
     /* 5374 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5385), // Rule ID 265 //
     /* 5379 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5382 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5382 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5385 */ // Label 362: @5385
     /* 5385 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5396), // Rule ID 295 //
     /* 5390 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5393 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5393 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5396 */ // Label 363: @5396
     /* 5396 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5407), // Rule ID 329 //
     /* 5401 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5404 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5404 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5407 */ // Label 364: @5407
     /* 5407 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5430), // Rule ID 128 //
     /* 5412 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 5415 */   // MIs[0] dst
     /* 5415 */   // No operand predicates
     /* 5415 */   // MIs[0] x
     /* 5415 */   // No operand predicates
     /* 5415 */   // MIs[0] y
     /* 5415 */   // No operand predicates
     /* 5415 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5419 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5424 */   // Combiner Rule #92: right_identity_one_fp
     /* 5424 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5429 */   GIR_EraseRootFromParent_Done,
     /* 5430 */ // Label 365: @5430
     /* 5430 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5450), // Rule ID 138 //
     /* 5435 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5438 */   // MIs[0] dst
     /* 5438 */   // No operand predicates
     /* 5438 */   // MIs[0] x
     /* 5438 */   // No operand predicates
     /* 5438 */   // MIs[0] y
     /* 5438 */   // No operand predicates
     /* 5438 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5442 */   // Combiner Rule #100: right_identity_neg_one_fp
     /* 5442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5445 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5447 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5449 */   GIR_EraseRootFromParent_Done,
     /* 5450 */ // Label 366: @5450
     /* 5450 */ GIM_Reject,
     /* 5451 */ // Label 63: @5451
     /* 5451 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5462), // Rule ID 253 //
     /* 5456 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5459 */   // Combiner Rule #167: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5459 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5462 */ // Label 367: @5462
     /* 5462 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5473), // Rule ID 268 //
     /* 5467 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5470 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5470 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5473 */ // Label 368: @5473
     /* 5473 */ GIM_Reject,
     /* 5474 */ // Label 64: @5474
     /* 5474 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5485), // Rule ID 252 //
     /* 5479 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5482 */   // Combiner Rule #167: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5482 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5485 */ // Label 369: @5485
     /* 5485 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5496), // Rule ID 267 //
     /* 5490 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5493 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5493 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5496 */ // Label 370: @5496
     /* 5496 */ GIM_Reject,
     /* 5497 */ // Label 65: @5497
     /* 5497 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5508), // Rule ID 251 //
     /* 5502 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5505 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5505 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5508 */ // Label 371: @5508
     /* 5508 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5519), // Rule ID 266 //
     /* 5513 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5516 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5516 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5519 */ // Label 372: @5519
     /* 5519 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5530), // Rule ID 298 //
     /* 5524 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5527 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5527 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5530 */ // Label 373: @5530
     /* 5530 */ GIM_Reject,
     /* 5531 */ // Label 66: @5531
     /* 5531 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5542), // Rule ID 299 //
     /* 5536 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5539 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5539 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5542 */ // Label 374: @5542
     /* 5542 */ GIM_Reject,
     /* 5543 */ // Label 67: @5543
     /* 5543 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5564), // Rule ID 196 //
     /* 5548 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 5551 */   // MIs[0] dst
     /* 5551 */   // No operand predicates
     /* 5551 */   // MIs[0] float
     /* 5551 */   // No operand predicates
     /* 5551 */   // MIs[0] int
     /* 5551 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5559 */   // MIs[1] imm
     /* 5559 */   // No operand predicates
     /* 5559 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5561 */   // Combiner Rule #146: expand_const_fpowi
     /* 5561 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5564 */ // Label 375: @5564
     /* 5564 */ GIM_Reject,
     /* 5565 */ // Label 68: @5565
     /* 5565 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5586), // Rule ID 178 //
     /* 5570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 5573 */   // MIs[0] dst
     /* 5573 */   // No operand predicates
     /* 5573 */   // MIs[0] src0
     /* 5573 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5581 */   // MIs[1] cst
     /* 5581 */   // No operand predicates
     /* 5581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5583 */   // Combiner Rule #136: constant_fold_flog2
     /* 5583 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5586 */ // Label 376: @5586
     /* 5586 */ GIM_Reject,
     /* 5587 */ // Label 69: @5587
     /* 5587 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5608), // Rule ID 175 //
     /* 5592 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 5595 */   // MIs[0] dst
     /* 5595 */   // No operand predicates
     /* 5595 */   // MIs[0] src0
     /* 5595 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5603 */   // MIs[1] cst
     /* 5603 */   // No operand predicates
     /* 5603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5605 */   // Combiner Rule #133: constant_fold_fneg
     /* 5605 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5608 */ // Label 377: @5608
     /* 5608 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5637), // Rule ID 126 //
     /* 5613 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 5616 */   // MIs[0] dst
     /* 5616 */   // No operand predicates
     /* 5616 */   // MIs[0] t
     /* 5616 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5624 */   // MIs[1] src
     /* 5624 */   // No operand predicates
     /* 5624 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5629 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5631 */   // Combiner Rule #90: fneg_fneg_fold
     /* 5631 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5636 */   GIR_EraseRootFromParent_Done,
     /* 5637 */ // Label 378: @5637
     /* 5637 */ GIM_Reject,
     /* 5638 */ // Label 70: @5638
     /* 5638 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5659), // Rule ID 179 //
     /* 5643 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5646 */   // MIs[0] dst
     /* 5646 */   // No operand predicates
     /* 5646 */   // MIs[0] src0
     /* 5646 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5650 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5654 */   // MIs[1] cst
     /* 5654 */   // No operand predicates
     /* 5654 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5656 */   // Combiner Rule #137: constant_fold_fptrunc
     /* 5656 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5659 */ // Label 379: @5659
     /* 5659 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5680), // Rule ID 136 //
     /* 5664 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 5667 */   // MIs[0] dst
     /* 5667 */   // No operand predicates
     /* 5667 */   // MIs[0] src1
     /* 5667 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 5675 */   // MIs[1] src0
     /* 5675 */   // No operand predicates
     /* 5675 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5677 */   // Combiner Rule #98: fptrunc_fpext_fold
     /* 5677 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 5680 */ // Label 380: @5680
     /* 5680 */ GIM_Reject,
     /* 5681 */ // Label 71: @5681
     /* 5681 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5702), // Rule ID 91 //
     /* 5686 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 5689 */   // MIs[0] dst
     /* 5689 */   // No operand predicates
     /* 5689 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5689 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5697 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5699 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 5699 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 5702 */ // Label 381: @5702
     /* 5702 */ GIM_Reject,
     /* 5703 */ // Label 72: @5703
     /* 5703 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5724), // Rule ID 92 //
     /* 5708 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 5711 */   // MIs[0] dst
     /* 5711 */   // No operand predicates
     /* 5711 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5711 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5721 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 5721 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 5724 */ // Label 382: @5724
     /* 5724 */ GIM_Reject,
     /* 5725 */ // Label 73: @5725
     /* 5725 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5736), // Rule ID 75 //
     /* 5730 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 5733 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 5733 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 5736 */ // Label 383: @5736
     /* 5736 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5751), // Rule ID 180 //
     /* 5741 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 5744 */   // MIs[0] dst
     /* 5744 */   // No operand predicates
     /* 5744 */   // MIs[0] Operand 1
     /* 5744 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5748 */   // Combiner Rule #138: itof_const_zero_fold_si
     /* 5748 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5751 */ // Label 384: @5751
     /* 5751 */ GIM_Reject,
     /* 5752 */ // Label 74: @5752
     /* 5752 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5763), // Rule ID 74 //
     /* 5757 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 5760 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 5760 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 5763 */ // Label 385: @5763
     /* 5763 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5778), // Rule ID 181 //
     /* 5768 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 5771 */   // MIs[0] dst
     /* 5771 */   // No operand predicates
     /* 5771 */   // MIs[0] Operand 1
     /* 5771 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5775 */   // Combiner Rule #139: itof_const_zero_fold_ui
     /* 5775 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5778 */ // Label 386: @5778
     /* 5778 */ GIM_Reject,
     /* 5779 */ // Label 75: @5779
     /* 5779 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5808), // Rule ID 19 //
     /* 5784 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5787 */   // MIs[0] dst
     /* 5787 */   // No operand predicates
     /* 5787 */   // MIs[0] src
     /* 5787 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5795 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5795 */   // No operand predicates
     /* 5795 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5800 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5802 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 5802 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5807 */   GIR_EraseRootFromParent_Done,
     /* 5808 */ // Label 387: @5808
     /* 5808 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5829), // Rule ID 176 //
     /* 5813 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 5816 */   // MIs[0] dst
     /* 5816 */   // No operand predicates
     /* 5816 */   // MIs[0] src0
     /* 5816 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5824 */   // MIs[1] cst
     /* 5824 */   // No operand predicates
     /* 5824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5826 */   // Combiner Rule #134: constant_fold_fabs
     /* 5826 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5829 */ // Label 388: @5829
     /* 5829 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5857), // Rule ID 257 //
     /* 5834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 5837 */   // MIs[0] dst
     /* 5837 */   // No operand predicates
     /* 5837 */   // MIs[0] tmp
     /* 5837 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5845 */   // MIs[1] x
     /* 5845 */   // No operand predicates
     /* 5845 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5847 */   // Combiner Rule #169: fabs_fneg_fold
     /* 5847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5850 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5852 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 5856 */   GIR_EraseRootFromParent_Done,
     /* 5857 */ // Label 389: @5857
     /* 5857 */ GIM_Reject,
     /* 5858 */ // Label 76: @5858
     /* 5858 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5887), // Rule ID 20 //
     /* 5863 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5866 */   // MIs[0] dst
     /* 5866 */   // No operand predicates
     /* 5866 */   // MIs[0] src
     /* 5866 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 5874 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5874 */   // No operand predicates
     /* 5874 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5881 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 5881 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5886 */   GIR_EraseRootFromParent_Done,
     /* 5887 */ // Label 390: @5887
     /* 5887 */ GIM_Reject,
     /* 5888 */ // Label 77: @5888
     /* 5888 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(5899), // Rule ID 192 //
     /* 5893 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5896 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 5896 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5899 */ // Label 391: @5899
     /* 5899 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(5910), // Rule ID 300 //
     /* 5904 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5907 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 5907 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5910 */ // Label 392: @5910
     /* 5910 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(5921), // Rule ID 330 //
     /* 5915 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5918 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 5918 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5921 */ // Label 393: @5921
     /* 5921 */ GIM_Reject,
     /* 5922 */ // Label 78: @5922
     /* 5922 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(5933), // Rule ID 193 //
     /* 5927 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5930 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 5930 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5933 */ // Label 394: @5933
     /* 5933 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(5944), // Rule ID 301 //
     /* 5938 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5941 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 5941 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5944 */ // Label 395: @5944
     /* 5944 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(5955), // Rule ID 331 //
     /* 5949 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5952 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 5952 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5955 */ // Label 396: @5955
     /* 5955 */ GIM_Reject,
     /* 5956 */ // Label 79: @5956
     /* 5956 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(5967), // Rule ID 332 //
     /* 5961 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5964 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 5964 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5967 */ // Label 397: @5967
     /* 5967 */ GIM_Reject,
     /* 5968 */ // Label 80: @5968
     /* 5968 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(5979), // Rule ID 333 //
     /* 5973 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5976 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 5976 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5979 */ // Label 398: @5979
     /* 5979 */ GIM_Reject,
     /* 5980 */ // Label 81: @5980
     /* 5980 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(5991), // Rule ID 194 //
     /* 5985 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5988 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 5988 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5991 */ // Label 399: @5991
     /* 5991 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6002), // Rule ID 302 //
     /* 5996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5999 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 5999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6002 */ // Label 400: @6002
     /* 6002 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6013), // Rule ID 334 //
     /* 6007 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6010 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6010 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6013 */ // Label 401: @6013
     /* 6013 */ GIM_Reject,
     /* 6014 */ // Label 82: @6014
     /* 6014 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6025), // Rule ID 195 //
     /* 6019 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 6022 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6022 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6025 */ // Label 402: @6025
     /* 6025 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6036), // Rule ID 303 //
     /* 6030 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6033 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6033 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6036 */ // Label 403: @6036
     /* 6036 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6047), // Rule ID 335 //
     /* 6041 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6044 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6044 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6047 */ // Label 404: @6047
     /* 6047 */ GIM_Reject,
     /* 6048 */ // Label 83: @6048
     /* 6048 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6059), // Rule ID 147 //
     /* 6053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 6056 */   // Combiner Rule #105: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6056 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 6059 */ // Label 405: @6059
     /* 6059 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6070), // Rule ID 149 //
     /* 6064 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 6067 */   // Combiner Rule #107: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6067 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 6070 */ // Label 406: @6070
     /* 6070 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6081), // Rule ID 182 //
     /* 6075 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 6078 */   // Combiner Rule #140: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6078 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6081 */ // Label 407: @6081
     /* 6081 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6092), // Rule ID 198 //
     /* 6086 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 6089 */   // Combiner Rule #148: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6089 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 6092 */ // Label 408: @6092
     /* 6092 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6103), // Rule ID 231 //
     /* 6097 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6100 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6100 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6103 */ // Label 409: @6103
     /* 6103 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6114), // Rule ID 280 //
     /* 6108 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6111 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6111 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6114 */ // Label 410: @6114
     /* 6114 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6137), // Rule ID 110 //
     /* 6119 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 6122 */   // MIs[0] dst
     /* 6122 */   // No operand predicates
     /* 6122 */   // MIs[0] lhs
     /* 6122 */   // No operand predicates
     /* 6122 */   // MIs[0] Operand 2
     /* 6122 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6126 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6131 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6131 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6136 */   GIR_EraseRootFromParent_Done,
     /* 6137 */ // Label 411: @6137
     /* 6137 */ GIM_Reject,
     /* 6138 */ // Label 84: @6138
     /* 6138 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6149), // Rule ID 244 //
     /* 6143 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6146 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6146 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6149 */ // Label 412: @6149
     /* 6149 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6160), // Rule ID 291 //
     /* 6154 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6157 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6157 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6160 */ // Label 413: @6160
     /* 6160 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6171), // Rule ID 312 //
     /* 6165 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6168 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6168 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6171 */ // Label 414: @6171
     /* 6171 */ GIM_Reject,
     /* 6172 */ // Label 85: @6172
     /* 6172 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6183), // Rule ID 245 //
     /* 6177 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6180 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6180 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6183 */ // Label 415: @6183
     /* 6183 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6194), // Rule ID 292 //
     /* 6188 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6191 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6191 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6194 */ // Label 416: @6194
     /* 6194 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6205), // Rule ID 313 //
     /* 6199 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6202 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6202 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6205 */ // Label 417: @6205
     /* 6205 */ GIM_Reject,
     /* 6206 */ // Label 86: @6206
     /* 6206 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6217), // Rule ID 246 //
     /* 6211 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6214 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6214 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6217 */ // Label 418: @6217
     /* 6217 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6228), // Rule ID 293 //
     /* 6222 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6225 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6225 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6228 */ // Label 419: @6228
     /* 6228 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6239), // Rule ID 314 //
     /* 6233 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6236 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6236 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6239 */ // Label 420: @6239
     /* 6239 */ GIM_Reject,
     /* 6240 */ // Label 87: @6240
     /* 6240 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6251), // Rule ID 247 //
     /* 6245 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6248 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6248 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6251 */ // Label 421: @6251
     /* 6251 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6262), // Rule ID 294 //
     /* 6256 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6259 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6259 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6262 */ // Label 422: @6262
     /* 6262 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6273), // Rule ID 315 //
     /* 6267 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6270 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6270 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6273 */ // Label 423: @6273
     /* 6273 */ GIM_Reject,
     /* 6274 */ // Label 88: @6274
     /* 6274 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6285), // Rule ID 85 //
     /* 6279 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 6282 */   // Combiner Rule #75: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6282 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 6285 */ // Label 424: @6285
     /* 6285 */ GIM_Reject,
     /* 6286 */ // Label 89: @6286
     /* 6286 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6297), // Rule ID 174 //
     /* 6291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 6294 */   // Combiner Rule #132: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 6297 */ // Label 425: @6297
     /* 6297 */ GIM_Reject,
     /* 6298 */ // Label 90: @6298
     /* 6298 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6309), // Rule ID 26 //
     /* 6303 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6306 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6306 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6309 */ // Label 426: @6309
     /* 6309 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6320), // Rule ID 66 //
     /* 6314 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 6317 */   // Combiner Rule #64: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6317 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 6320 */ // Label 427: @6320
     /* 6320 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6331), // Rule ID 100 //
     /* 6325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6328 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6331 */ // Label 428: @6331
     /* 6331 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6370), // Rule ID 38 //
     /* 6336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6339 */   // MIs[0] root
     /* 6339 */   // No operand predicates
     /* 6339 */   // MIs[0] src
     /* 6339 */   // No operand predicates
     /* 6339 */   // MIs[0] elt
     /* 6339 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6347 */   // MIs[1] src
     /* 6347 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6352 */   // MIs[1] idx
     /* 6352 */   // No operand predicates
     /* 6352 */   // MIs[0] idx
     /* 6352 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6357 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6362 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6364 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6364 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6369 */   GIR_EraseRootFromParent_Done,
     /* 6370 */ // Label 429: @6370
     /* 6370 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6403), // Rule ID 24 //
     /* 6375 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6378 */   // MIs[0] root
     /* 6378 */   // No operand predicates
     /* 6378 */   // MIs[0] src
     /* 6378 */   // No operand predicates
     /* 6378 */   // MIs[0] elt
     /* 6378 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6386 */   // MIs[0] idx
     /* 6386 */   // No operand predicates
     /* 6386 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6390 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6395 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6397 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6397 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6402 */   GIR_EraseRootFromParent_Done,
     /* 6403 */ // Label 430: @6403
     /* 6403 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6427), // Rule ID 23 //
     /* 6408 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6411 */   // MIs[0] root
     /* 6411 */   // No operand predicates
     /* 6411 */   // MIs[0] src
     /* 6411 */   // No operand predicates
     /* 6411 */   // MIs[0] elt
     /* 6411 */   // No operand predicates
     /* 6411 */   // MIs[0] idx
     /* 6411 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6419 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6421 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6424 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6426 */   GIR_EraseRootFromParent_Done,
     /* 6427 */ // Label 431: @6427
     /* 6427 */ GIM_Reject,
     /* 6428 */ // Label 91: @6428
     /* 6428 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6439), // Rule ID 25 //
     /* 6433 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6436 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6436 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6439 */ // Label 432: @6439
     /* 6439 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6450), // Rule ID 67 //
     /* 6444 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6447 */   // Combiner Rule #65: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6447 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6450 */ // Label 433: @6450
     /* 6450 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6461), // Rule ID 73 //
     /* 6455 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 6458 */   // Combiner Rule #69: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6458 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 6461 */ // Label 434: @6461
     /* 6461 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6472), // Rule ID 101 //
     /* 6466 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6469 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6469 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6472 */ // Label 435: @6472
     /* 6472 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6496), // Rule ID 36 //
     /* 6477 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6480 */   // MIs[0] root
     /* 6480 */   // No operand predicates
     /* 6480 */   // MIs[0] src
     /* 6480 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6488 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6491 */   // MIs[1] x
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[1] y
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[1] z
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[1] a
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[1] b
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[1] c
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[1] d
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[1] e
     /* 6491 */   // No operand predicates
     /* 6491 */   // MIs[0] idx
     /* 6491 */   // No operand predicates
     /* 6491 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6493 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6493 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6496 */ // Label 436: @6496
     /* 6496 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6520), // Rule ID 35 //
     /* 6501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6504 */   // MIs[0] root
     /* 6504 */   // No operand predicates
     /* 6504 */   // MIs[0] src
     /* 6504 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6512 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6515 */   // MIs[1] x
     /* 6515 */   // No operand predicates
     /* 6515 */   // MIs[1] y
     /* 6515 */   // No operand predicates
     /* 6515 */   // MIs[1] z
     /* 6515 */   // No operand predicates
     /* 6515 */   // MIs[1] a
     /* 6515 */   // No operand predicates
     /* 6515 */   // MIs[1] b
     /* 6515 */   // No operand predicates
     /* 6515 */   // MIs[1] c
     /* 6515 */   // No operand predicates
     /* 6515 */   // MIs[1] d
     /* 6515 */   // No operand predicates
     /* 6515 */   // MIs[0] idx
     /* 6515 */   // No operand predicates
     /* 6515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6517 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6517 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6520 */ // Label 437: @6520
     /* 6520 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6544), // Rule ID 34 //
     /* 6525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6528 */   // MIs[0] root
     /* 6528 */   // No operand predicates
     /* 6528 */   // MIs[0] src
     /* 6528 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6536 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6539 */   // MIs[1] x
     /* 6539 */   // No operand predicates
     /* 6539 */   // MIs[1] y
     /* 6539 */   // No operand predicates
     /* 6539 */   // MIs[1] z
     /* 6539 */   // No operand predicates
     /* 6539 */   // MIs[1] a
     /* 6539 */   // No operand predicates
     /* 6539 */   // MIs[1] b
     /* 6539 */   // No operand predicates
     /* 6539 */   // MIs[1] c
     /* 6539 */   // No operand predicates
     /* 6539 */   // MIs[0] idx
     /* 6539 */   // No operand predicates
     /* 6539 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6541 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6541 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6544 */ // Label 438: @6544
     /* 6544 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6568), // Rule ID 33 //
     /* 6549 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6552 */   // MIs[0] root
     /* 6552 */   // No operand predicates
     /* 6552 */   // MIs[0] src
     /* 6552 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6560 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6563 */   // MIs[1] x
     /* 6563 */   // No operand predicates
     /* 6563 */   // MIs[1] y
     /* 6563 */   // No operand predicates
     /* 6563 */   // MIs[1] z
     /* 6563 */   // No operand predicates
     /* 6563 */   // MIs[1] a
     /* 6563 */   // No operand predicates
     /* 6563 */   // MIs[1] b
     /* 6563 */   // No operand predicates
     /* 6563 */   // MIs[0] idx
     /* 6563 */   // No operand predicates
     /* 6563 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6565 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6565 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6568 */ // Label 439: @6568
     /* 6568 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6592), // Rule ID 32 //
     /* 6573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6576 */   // MIs[0] root
     /* 6576 */   // No operand predicates
     /* 6576 */   // MIs[0] src
     /* 6576 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6580 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6584 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6587 */   // MIs[1] x
     /* 6587 */   // No operand predicates
     /* 6587 */   // MIs[1] y
     /* 6587 */   // No operand predicates
     /* 6587 */   // MIs[1] z
     /* 6587 */   // No operand predicates
     /* 6587 */   // MIs[1] a
     /* 6587 */   // No operand predicates
     /* 6587 */   // MIs[0] idx
     /* 6587 */   // No operand predicates
     /* 6587 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6589 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6589 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6592 */ // Label 440: @6592
     /* 6592 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6616), // Rule ID 31 //
     /* 6597 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6600 */   // MIs[0] root
     /* 6600 */   // No operand predicates
     /* 6600 */   // MIs[0] src
     /* 6600 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6608 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6611 */   // MIs[1] x
     /* 6611 */   // No operand predicates
     /* 6611 */   // MIs[1] y
     /* 6611 */   // No operand predicates
     /* 6611 */   // MIs[1] z
     /* 6611 */   // No operand predicates
     /* 6611 */   // MIs[0] idx
     /* 6611 */   // No operand predicates
     /* 6611 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6613 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6613 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6616 */ // Label 441: @6616
     /* 6616 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6650), // Rule ID 27 //
     /* 6621 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6624 */   // MIs[0] root
     /* 6624 */   // No operand predicates
     /* 6624 */   // MIs[0] src
     /* 6624 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6632 */   // MIs[1] x
     /* 6632 */   // No operand predicates
     /* 6632 */   // MIs[1] value
     /* 6632 */   // No operand predicates
     /* 6632 */   // MIs[1] idx
     /* 6632 */   // No operand predicates
     /* 6632 */   // MIs[0] idx
     /* 6632 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6637 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6644 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6644 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6649 */   GIR_EraseRootFromParent_Done,
     /* 6650 */ // Label 442: @6650
     /* 6650 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6671), // Rule ID 28 //
     /* 6655 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6658 */   // MIs[0] root
     /* 6658 */   // No operand predicates
     /* 6658 */   // MIs[0] src
     /* 6658 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6666 */   // MIs[1] x
     /* 6666 */   // No operand predicates
     /* 6666 */   // MIs[1] value
     /* 6666 */   // No operand predicates
     /* 6666 */   // MIs[1] idx2
     /* 6666 */   // No operand predicates
     /* 6666 */   // MIs[0] idx1
     /* 6666 */   // No operand predicates
     /* 6666 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6668 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 6668 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 6671 */ // Label 443: @6671
     /* 6671 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6700), // Rule ID 37 //
     /* 6676 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 6679 */   // MIs[0] root
     /* 6679 */   // No operand predicates
     /* 6679 */   // MIs[0] src
     /* 6679 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6683 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 6687 */   // MIs[1] src1
     /* 6687 */   // No operand predicates
     /* 6687 */   // MIs[1] src2
     /* 6687 */   // No operand predicates
     /* 6687 */   // MIs[1] mask
     /* 6687 */   // No operand predicates
     /* 6687 */   // MIs[0] idx
     /* 6687 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6691 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6695 */   // MIs[2] imm
     /* 6695 */   // No operand predicates
     /* 6695 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6697 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 6697 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 6700 */ // Label 444: @6700
     /* 6700 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6724), // Rule ID 30 //
     /* 6705 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 6708 */   // MIs[0] root
     /* 6708 */   // No operand predicates
     /* 6708 */   // MIs[0] src
     /* 6708 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6716 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 6719 */   // MIs[1] x
     /* 6719 */   // No operand predicates
     /* 6719 */   // MIs[1] y
     /* 6719 */   // No operand predicates
     /* 6719 */   // MIs[0] idx
     /* 6719 */   // No operand predicates
     /* 6719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6721 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 6721 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6724 */ // Label 445: @6724
     /* 6724 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6756), // Rule ID 29 //
     /* 6729 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 6732 */   // MIs[0] root
     /* 6732 */   // No operand predicates
     /* 6732 */   // MIs[0] src
     /* 6732 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 6740 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 6743 */   // MIs[1] unused
     /* 6743 */   // No operand predicates
     /* 6743 */   // MIs[0] idx
     /* 6743 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6747 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6751 */   // MIs[2] imm
     /* 6751 */   // No operand predicates
     /* 6751 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6753 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 6753 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 6756 */ // Label 446: @6756
     /* 6756 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6780), // Rule ID 21 //
     /* 6761 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 6764 */   // MIs[0] root
     /* 6764 */   // No operand predicates
     /* 6764 */   // MIs[0] vector
     /* 6764 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6772 */   // MIs[0] idx
     /* 6772 */   // No operand predicates
     /* 6772 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6774 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 6774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6777 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6779 */   GIR_EraseRootFromParent_Done,
     /* 6780 */ // Label 447: @6780
     /* 6780 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6804), // Rule ID 22 //
     /* 6785 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 6788 */   // MIs[0] root
     /* 6788 */   // No operand predicates
     /* 6788 */   // MIs[0] vector
     /* 6788 */   // No operand predicates
     /* 6788 */   // MIs[0] idx
     /* 6788 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6796 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6798 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 6798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6801 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6803 */   GIR_EraseRootFromParent_Done,
     /* 6804 */ // Label 448: @6804
     /* 6804 */ GIM_Reject,
     /* 6805 */ // Label 92: @6805
     /* 6805 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6816), // Rule ID 96 //
     /* 6810 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 6813 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 6816 */ // Label 449: @6816
     /* 6816 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6827), // Rule ID 98 //
     /* 6821 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 6824 */   // Combiner Rule #79: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6824 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 6827 */ // Label 450: @6827
     /* 6827 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6838), // Rule ID 343 //
     /* 6832 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 6835 */   // Combiner Rule #198: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6835 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 6838 */ // Label 451: @6838
     /* 6838 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6849), // Rule ID 345 //
     /* 6843 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 6846 */   // Combiner Rule #200: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6846 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 6849 */ // Label 452: @6849
     /* 6849 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6870), // Rule ID 344 //
     /* 6854 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 6857 */   // MIs[0] root
     /* 6857 */   // No operand predicates
     /* 6857 */   // MIs[0] src1
     /* 6857 */   // No operand predicates
     /* 6857 */   // MIs[0] undef
     /* 6857 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6865 */   // MIs[0] mask
     /* 6865 */   // No operand predicates
     /* 6865 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6867 */   // Combiner Rule #199: combine_shuffle_undef_rhs
     /* 6867 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 6870 */ // Label 453: @6870
     /* 6870 */ GIM_Reject,
     /* 6871 */ // Label 93: @6871
     /* 6871 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(6915), // Rule ID 222 //
     /* 6876 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 6879 */   // MIs[0] d
     /* 6879 */   // No operand predicates
     /* 6879 */   // MIs[0] src
     /* 6879 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6883 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6887 */   // MIs[1] rev
     /* 6887 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6891 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6895 */   // MIs[2] val
     /* 6895 */   // No operand predicates
     /* 6895 */   // MIs[1] amt
     /* 6895 */   // No operand predicates
     /* 6895 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 6899 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6901 */   // Combiner Rule #159: bitreverse_lshr
     /* 6901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6904 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6906 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 6910 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 6914 */   GIR_EraseRootFromParent_Done,
     /* 6915 */ // Label 454: @6915
     /* 6915 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(6959), // Rule ID 221 //
     /* 6920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 6923 */   // MIs[0] d
     /* 6923 */   // No operand predicates
     /* 6923 */   // MIs[0] src
     /* 6923 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6931 */   // MIs[1] rev
     /* 6931 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6935 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6939 */   // MIs[2] val
     /* 6939 */   // No operand predicates
     /* 6939 */   // MIs[1] amt
     /* 6939 */   // No operand predicates
     /* 6939 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 6943 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6945 */   // Combiner Rule #158: bitreverse_shl
     /* 6945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6948 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6950 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 6954 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 6958 */   GIR_EraseRootFromParent_Done,
     /* 6959 */ // Label 455: @6959
     /* 6959 */ GIM_Reject,
     /* 6960 */ // Label 94: @6960
     /* 6960 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(6981), // Rule ID 177 //
     /* 6965 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 6968 */   // MIs[0] dst
     /* 6968 */   // No operand predicates
     /* 6968 */   // MIs[0] src0
     /* 6968 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6976 */   // MIs[1] cst
     /* 6976 */   // No operand predicates
     /* 6976 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6978 */   // Combiner Rule #135: constant_fold_fsqrt
     /* 6978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6981 */ // Label 456: @6981
     /* 6981 */ GIM_Reject,
     /* 6982 */ // Label 95: @6982
     /* 6982 */ GIM_Reject,
     /* 6983 */ }; // Size: 6983 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

